class UITankClassLWStrategyScreenListener extends UIStrategyScreenListener;

event OnInit(UIScreen Screen)
{
    if (IsInStrategy())
    {
		AddSoldierUnlockTemplate('OfficerTrainingSchool', 'TankLWHackSeminarUnlock');
		AddSoldierUnlockTemplate('OfficerTrainingSchool', 'TankLWResilienceUnlock');

		//if (Screen.IsA('UIAfterAction'))
		//{
			//// When the after action screen gets shown, check for units with TankLWWoundCare that have wound timers
			//ApplyTankLWWoundCareToSquadWoundTimers();
		//}
	}
}

static function AddSoldierUnlockTemplate(name facilityName, name unlockName)
{
	local X2FacilityTemplate FacilityTemplate;

	// Find the GTS facility template
	FacilityTemplate = X2FacilityTemplate(class'X2StrategyElementTemplateManager'.static.GetStrategyElementTemplateManager().FindStrategyElementTemplate(facilityName));
	if (FacilityTemplate == none)
	{
		//`LOG("TankClassLW: Failed to update " @ facilityName @ " facility template with " @ unlockName @ " (facility template not found).");
		return;
	}

	if (FacilityTemplate.SoldierUnlockTemplates.Find(unlockName) != INDEX_NONE)
	{
		//`LOG("TankClassLW: Did not update GTS template with " @ unlockName @ " (already added).");
	}
	else
	{
		// Update the GTS template with the specified soldier unlock
		FacilityTemplate.SoldierUnlockTemplates.AddItem(unlockName);

		`LOG("TankClassLW: Updated " @ facilityName @ " template with " @ unlockName @ ".");
	}
}

