//---------------------------------------------------------------------------------------
//  FILE:    X2Ability_TankLWAbilitySet.uc
//  AUTHOR:  Phantom
//  PURPOSE: Defines abilities used by the TankClassLW.
//  SUPPORT: Modding Community
//---------------------------------------------------------------------------------------

class X2Ability_TankLWAbilitySet extends X2Ability config(TankClassLW);

//---------------------------------------------------------------------------------------------------
// ------------------------------------Variablen-----------------------------------------------------
//---------------------------------------------------------------------------------------------------

var name TankLWProtectionProtocolEffectName;
var name TankLWProtectionProtocolCDREffectName;
var name TankLWProtectionProtocolMeleeCDREffectName;
var name TankLWProtectionProtocolMDREffectName;
var name TankLWProtectionProtocolMeleeMDREffectName;
var name TankLWProtectionProtocolBDREffectName;
var name TankLWProtectionProtocolMeleeBDREffectName;
var name TankLWShieldedEffectName;
var name TankLWTeamShieldedEffectName;
var name TankLWDecoyUtilityEffectName;
var name TankLWDecoyEffectName;
var name TankLWCombatDrugsUtilityEffectName;
var name TankLWCombatDrugsEffectName;
var name TankLWChallengeEffectName;
var name TankLWChallengeAimEffectName;
var name TankLWMasochistEffectName;

var name TankLWHereIAmAbilityName;
var name TankLWProtectionProtocolAbilityName;

var config int       RESILIENCE_CRIT_REDUCTION;

var config int       HACKSEMINAR_HACK_BONUS;

var config int       PROTECTIONPROTOCOL_COOLDOWN;
var config int       PROTECTIONPROTOCOL_DODGE_BONUS;
var config int       PROTECTIONPROTOCOL_DODGE_MK2_BONUS;
var config int       PROTECTIONPROTOCOL_DODGE_MK3_BONUS;
var config int       PROTECTIONPROTOCOL_SHIELDHP_CV;
var config int       PROTECTIONPROTOCOL_SHIELDHP_MG;
var config int       PROTECTIONPROTOCOL_SHIELDHP_BM;
var config float     PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION;
var config float     PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION;
var config float     PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION;
var config float     PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION;
var config float     PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION;
var config float     PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION;
var localized string TankLWProtectionProtocolDescriptionName;
var localized string TankLWProtectionProtocolDamageReductionDescriptionName;
var localized string TankLWProtectionProtocolDamageReductionSecondDescriptionName;
var localized string TankLWProtectionProtocolDamageReductionThirdDescriptionName;
var localized string TankLWProtectionProtocolShieldedDescriptionName;
var localized string TankLWProtectionProtocolShieldedSecondDescriptionName;
var localized string TankLWProtectionProtocolShieldRemovedMsgName;

var config int       ADVANCEDSTORAGE_COOLDOWN_INCREASE;

var config int       HERE_I_AM_COOLDOWN;
var config int       HERE_I_AM_CRIT_REDUCTION;
var config int       HERE_I_AM_HIT_MODIFIER;
var config bool      HERE_I_AM_AWC;
var localized string TankLWHereIAmDescriptionName;
var localized string TankLWHereIAmSecondDescriptionName;
var localized string TankLWHereIAmCritDescriptionName;
var localized string TankLWHereIAmCritSecondDescriptionName;

var config bool      STEADFAST_AWC;

var config int       BALLISTICVESTS_ARMOR_CHANCE;
var config int       BALLISTICVESTS_ARMOR_MITIGATION;
var config bool      BALLISTICVESTS_AWC;

var config int       TEAMSHIELD_CHARGES;
var config int       TEAMSHIELD_COOLDOWN;
var config int		 TEAMSHIELD_DURATION;
var config float     TEAMSHIELD_RANGE_METERS;
var config int       TEAMSHIELD_SHIELDHP_CV;
var config int       TEAMSHIELD_SHIELDHP_MG;
var config int       TEAMSHIELD_SHIELDHP_BM;
var config bool      TEAMSHIELD_AWC;
var localized string TankLWTeamShieldRemovedMsgName;

var config bool      DECOY_AWC;

var config bool      COMBATDRUGS_AWC;

var config float     SHOCKABSORBANTARMOR_DAMAGE_REDUCTION;
var config int       SHOCKABSORBANTARMOR_TILES;
var config bool      SHOCKABSORBANTARMOR_AWC;

var config int       SURVIVALTRAINING_DODGE;
var config int       SURVIVALTRAINING_DEFENSE;
var config int       SURVIVALTRAINING_CHARGES;
var config int       SURVIVALTRAINING_REGEN_AMOUNT;
var config int       SURVIVALTRAINING_MAX_REGEN_AMOUNT;
var config bool      SURVIVALTRAINING_AWC;

var config int       SHIELDHIT_MELEE_HITMOD;
var config int       SHIELDHIT_MELEE_CRITMOD;
var config int       SHIELDHIT_MELEE_CONVENTIONAL_DAMAGE;
var config int       SHIELDHIT_MELEE_CONVENTIONAL_SPREAD;
var config int       SHIELDHIT_MELEE_CONVENTIONAL_CRIT;
var config int       SHIELDHIT_MELEE_MAGNETIC_DAMAGE;
var config int       SHIELDHIT_MELEE_MAGNETIC_SPREAD;
var config int       SHIELDHIT_MELEE_MAGNETIC_CRIT;
var config int       SHIELDHIT_MELEE_BEAM_DAMAGE;
var config int       SHIELDHIT_MELEE_BEAM_SPREAD;
var config int       SHIELDHIT_MELEE_BEAM_CRIT;

var config int       CHALLENGE_COOLDOWN;
var config int       CHALLENGE_DURATION;
var config int       CHALLENGE_AIM_BONUS;
var config int       CHALLENGE_CRIT_CHANCE_BONUS;
var config float     CHALLENGE_MOTIVATION_RADIUS;
var config int       CHALLENGE_MOTIVATION_AIM_BONUS;
var config int       CHALLENGE_MOTIVATION_CRIT_BONUS;
var config int       CHALLENGE_MOTIVATION_MOBILITY_BONUS;
var config int       CHALLENGE_MOTIVATION_DEFENSE_BONUS;
var config int       CHALLENGE_MOTIVATION_DODGE_BONUS;
var config int       CHALLENGE_MOTIVATION_WILL_BONUS;
var config int       CHALLENGE_MOTIVATION_DURATION;
var config bool      CHALLENGE_AWC;
var localized string TankLWChallengeDescriptionName;
var localized string ChallengeFriendlyName;
var localized string ChallengeEffectAcquiredString;
var localized string ChallengeEffectTickedString;
var localized string ChallengeEffectLostString;

var config int       WARNING_SHOT_AMMO;
var config int       WARNING_SHOT_COOLDOWN;
var config int       WARNING_SHOT_MISS_PANIC_CHANCE;
var config int       WARNING_SHOT_HIT_PANIC_CHANCE;
var config bool      WARNING_SHOT_AWC;

var config bool      REVENGE_AWC;

var config bool      PREFIRE_AWC;

var config int       STANDBY_AIM_BONUS;
var config int       STANDBY_BONUS_DAMAGE;
var config int		 STANDBY_BONUS_CRIT_CHANCE;
var config bool		 STANDBY_AWC;

var config float     COVERPROTECTION_DAMAGE_REDUCTION;
var config bool      COVERPROTECTION_AWC;

var config int       MASOCHIST_AIM_BONUS;
var config int       MASOCHIST_CRIT_CHANCE_BONUS;
var config bool      MASOCHIST_AWC;

var localized string TankLWEverSafeShieldedFriendlyName;

var localized string TankLWLastChanceProtectionProtocolFriendlyName;
var localized string TankLWLastChanceProtectionProtocolSecondFriendlyName;

//---------------------------------------------------------------------------------------------------
// ------------------------------------Templates-----------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;
	
	Templates.AddItem(TankLWResilience());
	Templates.AddItem(TankLWHackSeminar());
	Templates.AddItem(TankLWProtectionProtocol());
	Templates.AddItem(TankLWAdvancedStorage());
	Templates.AddItem(TankLWSteadfast());
	Templates.AddItem(PurePassive('TankLWSteadfastPassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_Steadfast_TankLW"));
	Templates.AddItem(TankLWBallisticVests());
	Templates.AddItem(PurePassive('TankLWBallisticVestsPassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_BallisticVests_TankLW"));
	Templates.AddItem(TankLWTeamShield());
	Templates.AddItem(TankLWDecoy());
	Templates.AddItem(PurePassive('TankLWDecoyPassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_Decoy_TankLW"));
	Templates.AddItem(TankLWCombatDrugs());
	Templates.AddItem(PurePassive('TankLWCombatDrugsPassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_CombatDrugs_TankLW"));
	Templates.AddItem(TankLWCombatStims());
	Templates.AddItem(TankLWHereIAm());
	Templates.Additem(TankLWShockAbsorbantArmor());
	Templates.AddItem(PurePassive('TankLWShockAbsorbantArmorPassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_ShockAbsorbantArmor_TankLW"));
	Templates.AddItem(TankLWEverSafe());
	Templates.AddItem(PurePassive('TankLWEverSafePassiveInfo', "img:///UILibrary_TankClassLW.UIPerk_EverSafe_TankLW"));
	Templates.Additem(TankLWSurvivalTraining());
	Templates.Additem(TankLWSurvivalTrainingHunkerDown());
	Templates.AddItem(TankLWShieldHit());
	Templates.AddItem(TankLWShieldHitRangeAttack());
	Templates.AddItem(TankLWChallenge());
	Templates.AddItem(TankLWChallengeAim());
	Templates.AddItem(TankLWChallengePassive());
	Templates.AddItem(BroadcastTankLWMotivation());
	Templates.AddItem(TankLWWarningShot());
	Templates.AddItem(TankLWWarningShotGraze());
	Templates.AddItem(TankLWRevenge());
	Templates.AddItem(TankLWRevengeShot());
	Templates.AddItem(TankLWPreFire());
	Templates.AddItem(TankLWPreFireShot());
	Templates.Additem(TankLWLastChance());
	Templates.Additem(TankLWLastChanceTriggered());
	Templates.Additem(TankLWStandBy());
	Templates.AddItem(TankLWMasochist());
	Templates.AddItem(TankLWCoverProtection());
	Templates.AddItem(PurePassive('TankLWCoverProtectionPassiveInfo', "img:///UILibrary_PerkIcons.UIPerk_one_for_all"));

	return Templates;
}

//---------------------------------------------------------------------------------------------------
// ------------------------------------GENERAL PATH--------------------------------------------------
//---------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------
// TankLWHackSeminar------------------GTS------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWHackSeminar()
{
	local X2AbilityTemplate						    Template;
	local X2Effect_PersistentStatChange		        PersistentStatChangeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWHackSeminar');

	Template.AdditionalAbilities.AddItem('HaywireProtocol');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_hackseminar_TankLW";
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.BuildPersistentEffect(1, true, true, true);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage, true,, Template.AbilitySourceName);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Hacking, default.HACKSEMINAR_HACK_BONUS);
	Template.AddTargetEffect(PersistentStatChangeEffect);

	//Template.SetUIStatMarkup(class'XLocalizedData'.default.TechLabel, eStat_Hacking, default.HACKSEMINAR_HACK_BONUS, true); //funktioniert anscheinend nur ber ability promotion oder items.

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWResilience------------------GTS-------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWResilience()
{
	local X2AbilityTemplate						    Template;
	local X2Effect_TankClassLWResilience			Resilience;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWResilience');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_resilience_TankLW";
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	Resilience = new class'X2Effect_TankClassLWResilience';
	Resilience.RESILIENCE_CRIT_MITIGATION_X2EFFECT = default.RESILIENCE_CRIT_REDUCTION;
	Resilience.BuildPersistentEffect(1, true, true, true);
	Resilience.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(Resilience);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWCoverProtection------------------------AWC--------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWCoverProtection()
{
	local X2AbilityTemplate						    Template;
	local X2AbilityTargetStyle                      TargetStyle;
	local X2AbilityTrigger						    Trigger;
	local X2Effect_TankClassLWCoverProtection		CoverProtectionEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWCoverProtection');

	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_one_for_all";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AdditionalAbilities.AddItem('TankLWCoverProtectionPassiveInfo');

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	CoverProtectionEffect = new class'X2Effect_TankClassLWCoverProtection';
	CoverProtectionEffect.COVERPROTECTION_DAMAGE_REDUCTION_X2EFFECT = default.COVERPROTECTION_DAMAGE_REDUCTION;
	CoverProtectionEffect.BuildPersistentEffect(1, true, false, false);
	Template.AddTargetEffect(CoverProtectionEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	Template.bCrossClassEligible = default.COVERPROTECTION_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWMasochist-----------------AWC---------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWMasochist()
{
	local X2AbilityTemplate						Template;
	local X2Effect_ToHitModifier                MasochistEffect;
	local X2Condition_TankLWMasochist           MasochistCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWMasochist');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_reaper";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	MasochistEffect = new class'X2Effect_ToHitModifier';
	MasochistEffect.EffectName = default.TankLWMasochistEffectName;
	MasochistEffect.DuplicateResponse = eDupe_Ignore;
	MasochistEffect.BuildPersistentEffect(1, true, false);
	MasochistEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	MasochistEffect.AddEffectHitModifier(eHit_Success, default.MASOCHIST_AIM_BONUS, Template.LocFriendlyName);
	MasochistEffect.AddEffectHitModifier(eHit_Crit, default.MASOCHIST_CRIT_CHANCE_BONUS, Template.LocFriendlyName);
	MasochistCondition = new class'X2Condition_TankLWMasochist';
	MasochistEffect.ToHitConditions.AddItem(MasochistCondition);
	Template.AddTargetEffect(MasochistEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	
	Template.bCrossClassEligible = default.MASOCHIST_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWHereIAm-----------------------------------Squaddie------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWHereIAm()
{
	local X2AbilityTemplate						Template;
	local X2Condition_UnitProperty              TargetProperty;
	local X2AbilityCooldown						Cooldown;
	local array<name>                           SkipExclusions;
	local X2Effect_TankClassLWHereIAm			TankLWHereIAmCritEffect, TankLWHereIAmDisplayEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, default.TankLWHereIAmAbilityName);

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.Hostility = eHostility_Neutral;
	Template.bLimitTargetIcons = true;
	Template.DisplayTargetHitChance = false;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SQUADDIE_PRIORITY;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_HereIAm_TankLW";
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = default.HERE_I_AM_COOLDOWN;
	Template.AbilityCooldown = Cooldown;

	Template.AbilityCosts.AddItem(default.FreeActionCost);

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);

	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	TargetProperty = new class'X2Condition_UnitProperty';
	TargetProperty.ExcludeDead = true;
	TargetProperty.ExcludeHostileToSource = true;
	TargetProperty.ExcludeFriendlyToSource = false;
	TargetProperty.RequireSquadmates = false;
	Template.AbilityTargetConditions.AddItem(TargetProperty);

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	TankLWHereIAmCritEffect = new class'X2Effect_TankClassLWHereIAm';
	TankLWHereIAmCritEffect.HERE_I_AM_CRIT_X2EFFECT = default.HERE_I_AM_CRIT_REDUCTION;
	TankLWHereIAmCritEffect.HERE_I_AM_HIT_X2EFFECT = default.HERE_I_AM_HIT_MODIFIER;
	TankLWHereIAmCritEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	TankLWHereIAmCritEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWHereIAmCritDescriptionName @ default.HERE_I_AM_CRIT_REDUCTION @ default.TankLWHereIAmCritSecondDescriptionName, Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(TankLWHereIAmCritEffect);

	TankLWHereIAmDisplayEffect = new class'X2Effect_TankClassLWHereIAm';
	TankLWHereIAmDisplayEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	TankLWHereIAmDisplayEffect.SetDisplayInfo(ePerkBuff_Penalty, Template.LocFriendlyName, default.TankLWHereIAmDescriptionName @ default.HERE_I_AM_HIT_MODIFIER @ default.TankLWHereIAmSecondDescriptionName, Template.IconImage, true,,Template.AbilitySourceName);
	Template.AddTargetEffect(TankLWHereIAmDisplayEffect);

	Template.CustomFireAnim = 'HL_SignalEncourageA';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;	
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.CinescriptCameraType = "Mark_Target";
	Template.ActivationSpeech = 'Explosion'; //ndern
	Template.bShowActivation = true;

	Template.ConcealmentRule = eConceal_Never;

	Template.bCrossClassEligible = default.HERE_I_AM_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWProtectionProtocol----------------------Squaddie--------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWProtectionProtocol()
{
	local X2AbilityTemplate								  Template;
	local X2AbilityCost_ActionPoints					  ActionPointCost;
	local X2Condition_UnitProperty						  TargetProperty;
	local X2Condition_UnitEffects						  EffectsCondition;
	local X2Condition_AbilitySourceWeapon				  ProtectionProtocolCDRCondition, ProtectionProtocolMDRCondition, ProtectionProtocolBDRCondition;
	local X2Condition_UnitStatCheck						  ProtectionProtocolShieldedCondition;
	local X2AbilityCooldown_TankLWProtectionProtocol	  Cooldown;
	local X2Effect_TankClassLWProtectionProtocol		  ProtectionProtocolEffect;
	local X2Effect_TankClassLWProtectionProtocolCDR		  ProtectionProtocolCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeCDR  ProtectionProtocolMeleeCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMDR		  ProtectionProtocolMDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeMDR  ProtectionProtocolMeleeMDREffect;
	local X2Effect_TankClassLWProtectionProtocolBDR		  ProtectionProtocolBDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeBDR  ProtectionProtocolMeleeBDREffect;
	local X2Effect_PersistentStatChange					  ProtectionProtocolShieldedEffect;
	local array<name>									  SkipExclusions;

	`CREATE_X2ABILITY_TEMPLATE(Template, default.TankLWProtectionProtocolAbilityName);

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.Hostility = eHostility_Defensive;
	Template.bLimitTargetIcons = true;
	Template.DisplayTargetHitChance = false;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SQUADDIE_PRIORITY;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	Cooldown = new class'X2AbilityCooldown_TankLWProtectionProtocol';
	Cooldown.iNumTurns = default.PROTECTIONPROTOCOL_COOLDOWN;
	Cooldown.PROTECTIONPROTOCOL_COOLDOWN_X2EFFECT = default.PROTECTIONPROTOCOL_COOLDOWN;
	Cooldown.ADVANCEDSTORAGE_COOLDOWN_INCREASE_X2EFFECT = default.ADVANCEDSTORAGE_COOLDOWN_INCREASE;
	Template.AbilityCooldown = Cooldown;

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);

	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SingleTargetWithSelf;

	TargetProperty = new class'X2Condition_UnitProperty';
	TargetProperty.ExcludeDead = true;
	TargetProperty.ExcludeHostileToSource = true;
	TargetProperty.ExcludeFriendlyToSource = false;
	TargetProperty.RequireSquadmates = false;
	Template.AbilityTargetConditions.AddItem(TargetProperty);

	Template.AbilityTargetConditions.AddItem(new class'X2Condition_TankLWProtectionProtocolTarget');

	EffectsCondition = new class'X2Condition_UnitEffects';
	EffectsCondition.AddExcludeEffect(default.TankLWProtectionProtocolEffectName, 'AA_UnitIsImmune');
	Template.AbilityTargetConditions.AddItem(EffectsCondition);

	ProtectionProtocolEffect = new class'X2Effect_TankClassLWProtectionProtocol';
	ProtectionProtocolEffect.EffectName = default.TankLWProtectionProtocolEffectName;
	ProtectionProtocolEffect.PROTECTIONPROTOCOL_DODGE_BONUS_X2EFFECT = default.PROTECTIONPROTOCOL_DODGE_BONUS;
	ProtectionProtocolEffect.DuplicateResponse = eDupe_Ignore; // Gremlin effects should always be setup such that a target already under the effect is invalid.
	ProtectionProtocolEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolEffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDescriptionName, Template.IconImage, true);
	Template.AddTargetEffect(ProtectionProtocolEffect);

	ProtectionProtocolCDREffect = new class'X2Effect_TankClassLWProtectionProtocolCDR';
	ProtectionProtocolCDREffect.EffectName = default.TankLWProtectionProtocolCDREffectName;
	ProtectionProtocolCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION;
	ProtectionProtocolCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, Template.IconImage, true);
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolCDREffect);

	ProtectionProtocolMeleeCDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeCDR';
	ProtectionProtocolMeleeCDREffect.EffectName = default.TankLWProtectionProtocolMeleeCDREffectName;
	ProtectionProtocolMeleeCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolMeleeCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeCDREffect);

	ProtectionProtocolMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMDR';
	ProtectionProtocolMDREffect.EffectName = default.TankLWProtectionProtocolMDREffectName;
	ProtectionProtocolMDREffect.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION;
	ProtectionProtocolMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, Template.IconImage, true);
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMDREffect);

	ProtectionProtocolMeleeMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeMDR';
	ProtectionProtocolMeleeMDREffect.EffectName = default.TankLWProtectionProtocolMeleeMDREffectName;
	ProtectionProtocolMeleeMDREffect.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMeleeMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeMDREffect);

	ProtectionProtocolBDREffect = new class'X2Effect_TankClassLWProtectionProtocolBDR';
	ProtectionProtocolBDREffect.EffectName = default.TankLWProtectionProtocolBDREffectName;
	ProtectionProtocolBDREffect.PROTECTIONPROTOCOL_BEAM_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION;
	ProtectionProtocolBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, Template.IconImage, true);
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolBDREffect);

	ProtectionProtocolMeleeBDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeBDR';
	ProtectionProtocolMeleeBDREffect.EffectName = default.TankLWProtectionProtocolMeleeBDREffectName;
	ProtectionProtocolMeleeBDREffect.PROTECTIONPROTOCOL_BEAM_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolMeleeBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeBDREffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_CV @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_CV, 'Gremlin_CV');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_MG @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_MG, 'Gremlin_MG');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_BM @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_BM, 'Gremlin_BM');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);
	
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	Template.bStationaryWeapon = true; //if the ability uses a cosmetic attached weapon (e.g. gremlin), don't move it to the target when the ability activates
	Template.BuildNewGameStateFn = class 'X2Ability_SpecialistAbilitySet'.static.AttachGremlinToTarget_BuildGameState;
	Template.BuildVisualizationFn = class 'X2Ability_SpecialistAbilitySet'.static.GremlinSingleTarget_BuildVisualization;
	Template.bSkipPerkActivationActions = true;
	Template.bShowActivation = true;
	Template.ActivationSpeech = 'NullShield';

	Template.CustomSelfFireAnim = 'NO_DefenseProtocolA';

	return Template;
}

static function X2Effect_PersistentStatChange CreateShieldedEffect(string FriendlyName, string LongDescription, int PROTECTIONPROTOCOL_SHIELDHP, name gremlinType)
{
	local X2Effect_EnergyShield					ShieldedEffect;
	local X2Condition_AbilitySourceWeapon       ShieldedEffectCondition;

	ShieldedEffect = new class'X2Effect_EnergyShield';
	ShieldedEffect.EffectName = default.TankLWShieldedEffectName;
	ShieldedEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ShieldedEffect.DuplicateResponse = eDupe_Ignore;
	ShieldedEffect.bRemoveWhenTargetDies = true;
	ShieldedEffect.SetDisplayInfo(ePerkBuff_Bonus, FriendlyName, LongDescription, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ShieldedEffect.AddPersistentStatChange(eStat_ShieldHP, PROTECTIONPROTOCOL_SHIELDHP);
	ShieldedEffect.EffectRemovedVisualizationFn = OnShieldRemoved_BuildVisualization;
	ShieldedEffectCondition = new class'X2Condition_AbilitySourceWeapon';
	ShieldedEffectCondition.MatchWeaponTemplate = gremlinType;
	ShieldedEffect.TargetConditions.AddItem(ShieldedEffectCondition);

	return ShieldedEffect;
}

simulated function OnShieldRemoved_BuildVisualization(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	local X2Action_PlaySoundAndFlyOver SoundAndFlyOver;

	if (XGUnit(BuildTrack.TrackActor).IsAlive())
	{
		SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, VisualizeGameState.GetContext()));
		SoundAndFlyOver.SetSoundAndFlyOverParameters(None, default.TankLWProtectionProtocolShieldRemovedMsgName, '', eColor_Bad, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", 0.75, true);
	}
}

//---------------------------------------------------------------------------------------------------
// ------------------------------------SURVIVAL TANK-------------------------------------------------
//---------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------
// TankLWSteadfast-----------------------Corporal----------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWSteadfast()
{
	local X2AbilityTemplate						    Template;
	local X2AbilityTargetStyle                      TargetStyle;
	local X2AbilityTrigger						    Trigger;
	local X2Effect_TankClassLWSteadfast		        SteadfastEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWSteadfast');

	Template.AdditionalAbilities.AddItem('TankLWSteadfastPassiveInfo');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Steadfast_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	SteadfastEffect = new class'X2Effect_TankClassLWSteadfast';
	SteadfastEffect.BuildPersistentEffect(1, true, false, false);
	Template.AddTargetEffect(SteadfastEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = default.STEADFAST_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWTeamShield------------------------Lieutenant------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2DataTemplate TankLWTeamShield()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_ActionPoints        ActionPointCost;
	local X2AbilityCharges                  Charges;
	local X2AbilityCost_Charges             ChargeCost;
	local X2AbilityCooldown                 Cooldown;
	local X2Condition_UnitProperty          UnitPropertyCondition;
	local X2Condition_UnitEffects           EffectsCondition;
	local X2Condition_UnitStatCheck         TeamShieldShieldedCondition;
	local X2Condition_TankLWShieldHitWeapon TankLWTeamShieldWeaponCondition;
	local X2AbilityTrigger_PlayerInput      InputTrigger;
	local X2Effect_PersistentStatChange     TeamShieldShieldedConventionalEffect, TeamShieldShieldedMagneticEffect, TeamShieldShieldedBeamEffect;
	local X2AbilityMultiTarget_Radius       MultiTarget;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWTeamShield');
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_TeamShield_TankLW";

	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.Hostility = eHostility_Defensive;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_LIEUTENANT_PRIORITY;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Charges = new class 'X2AbilityCharges';
	Charges.InitialCharges = default.TEAMSHIELD_CHARGES;
	Template.AbilityCharges = Charges;

	ChargeCost = new class'X2AbilityCost_Charges';
	ChargeCost.NumCharges = 1;
	Template.AbilityCosts.AddItem(ChargeCost);

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = default.TEAMSHIELD_COOLDOWN;
	Template.AbilityCooldown = Cooldown;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	MultiTarget = new class'X2AbilityMultiTarget_Radius';
	MultiTarget.fTargetRadius = default.TEAMSHIELD_RANGE_METERS;
	MultiTarget.bIgnoreBlockingCover = true;
	Template.AbilityMultiTargetStyle = MultiTarget;

	InputTrigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(InputTrigger);

	UnitPropertyCondition = new class'X2Condition_UnitProperty';
	UnitPropertyCondition.ExcludeDead = true;
	UnitPropertyCondition.ExcludeFriendlyToSource = false;
	UnitPropertyCondition.ExcludeHostileToSource = true;
	UnitPropertyCondition.ExcludeCivilian = true;
	UnitPropertyCondition.FailOnNonUnits = true;
	Template.AbilityMultiTargetConditions.AddItem(UnitPropertyCondition);

	EffectsCondition = new class'X2Condition_UnitEffects';
	EffectsCondition.AddExcludeEffect(default.TankLWTeamShieldedEffectName, 'AA_UnitIsImmune');
	Template.AbilityMultiTargetConditions.AddItem(EffectsCondition);

	TeamShieldShieldedConventionalEffect = CreateTeamShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.TEAMSHIELD_SHIELDHP_CV @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.TEAMSHIELD_SHIELDHP_CV);
	TeamShieldShieldedCondition = new class'X2Condition_UnitStatCheck';
	TeamShieldShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	TeamShieldShieldedConventionalEffect.TargetConditions.AddItem(TeamShieldShieldedCondition);
	TankLWTeamShieldWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWTeamShieldWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWTeamShieldWeaponCondition.RequireWeaponTech = 'conventional';
	TeamShieldShieldedConventionalEffect.TargetConditions.AddItem(TankLWTeamShieldWeaponCondition);
	Template.AddShooterEffect(TeamShieldShieldedConventionalEffect);
	Template.AddMultiTargetEffect(TeamShieldShieldedConventionalEffect);

	TeamShieldShieldedMagneticEffect = CreateTeamShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.TEAMSHIELD_SHIELDHP_MG @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.TEAMSHIELD_SHIELDHP_MG);
	TeamShieldShieldedCondition = new class'X2Condition_UnitStatCheck';
	TeamShieldShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	TeamShieldShieldedMagneticEffect.TargetConditions.AddItem(TeamShieldShieldedCondition);
	TankLWTeamShieldWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWTeamShieldWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWTeamShieldWeaponCondition.RequireWeaponTech = 'magnetic';
	TeamShieldShieldedMagneticEffect.TargetConditions.AddItem(TankLWTeamShieldWeaponCondition);
	Template.AddShooterEffect(TeamShieldShieldedMagneticEffect);
	Template.AddMultiTargetEffect(TeamShieldShieldedMagneticEffect);

	TeamShieldShieldedBeamEffect = CreateTeamShieldedEffect(Template.LocFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.TEAMSHIELD_SHIELDHP_BM @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.TEAMSHIELD_SHIELDHP_BM);
	TeamShieldShieldedCondition = new class'X2Condition_UnitStatCheck';
	TeamShieldShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	TeamShieldShieldedBeamEffect.TargetConditions.AddItem(TeamShieldShieldedCondition);
	TankLWTeamShieldWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWTeamShieldWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWTeamShieldWeaponCondition.RequireWeaponTech = 'beam';
	TeamShieldShieldedBeamEffect.TargetConditions.AddItem(TankLWTeamShieldWeaponCondition);
	Template.AddShooterEffect(TeamShieldShieldedBeamEffect);
	Template.AddMultiTargetEffect(TeamShieldShieldedBeamEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = Shielded_BuildVisualization;
	Template.CinescriptCameraType = "AdvShieldBearer_EnergyShieldArmor"; //bearbeiten
	Template.ActivationSpeech = 'NullShield';

	Template.ConcealmentRule = eConceal_Never; //breaks concealment if used.

	Template.bCrossClassEligible = default.TEAMSHIELD_AWC;
	
	return Template;
}

static function X2Effect_PersistentStatChange CreateTeamShieldedEffect(string FriendlyName, string LongDescription, int TEAMSHIELD_SHIELDHP)
{
	local X2Effect_EnergyShield					ShieldedEffect;

	ShieldedEffect = new class'X2Effect_EnergyShield';
	ShieldedEffect.EffectName = default.TankLWTeamShieldedEffectName;
	ShieldedEffect.BuildPersistentEffect(default.TEAMSHIELD_DURATION, false, true, false, eGameRule_PlayerTurnBegin);
	ShieldedEffect.DuplicateResponse = eDupe_Refresh;
	ShieldedEffect.bRemoveWhenTargetDies = true;
	ShieldedEffect.SetDisplayInfo(ePerkBuff_Bonus, FriendlyName, LongDescription, "img:///UILibrary_TankClassLW.UIPerk_TeamShield_TankLW", true);
	ShieldedEffect.AddPersistentStatChange(eStat_ShieldHP, TEAMSHIELD_SHIELDHP);
	ShieldedEffect.EffectRemovedVisualizationFn = OnTeamShieldRemoved_BuildVisualization;

	return ShieldedEffect;
}

simulated function OnTeamShieldRemoved_BuildVisualization(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	local X2Action_PlaySoundAndFlyOver SoundAndFlyOver;

	if (XGUnit(BuildTrack.TrackActor).IsAlive())
	{
		SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, VisualizeGameState.GetContext()));
		SoundAndFlyOver.SetSoundAndFlyOverParameters(None, default.TankLWTeamShieldRemovedMsgName, '', eColor_Bad, "img:///UILibrary_TankClassLW.UIPerk_TeamShield_TankLW", 0.75, true);
	}
}

simulated function Shielded_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory History;
	local XComGameStateContext_Ability  Context;
	local StateObjectReference InteractingUnitRef;
	local VisualizationTrack EmptyTrack;
	local VisualizationTrack BuildTrack;
	local X2Action_PlayAnimation PlayAnimationAction;

	History = `XCOMHISTORY;

	Context = XComGameStateContext_Ability(VisualizeGameState.GetContext());
	InteractingUnitRef = Context.InputContext.SourceObject;

	//Configure the visualization track for the shooter
	//****************************************************************************************
	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(InteractingUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(InteractingUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(InteractingUnitRef.ObjectID);

	PlayAnimationAction = X2Action_PlayAnimation(class'X2Action_PlayAnimation'.static.AddToVisualizationTrack(BuildTrack, Context));
	PlayAnimationAction.Params.AnimName = 'HL_LootBodyStartA';

	OutVisualizationTracks.AddItem(BuildTrack);
}

//---------------------------------------------------------------------------------------------------
// TankLWAdvancedStorage------------------------Captain----------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWAdvancedStorage()
{
	local X2AbilityTemplate             Template;
	local X2Effect_Persistent           PersistentEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWAdvancedStorage');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_AdvancedStorage_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	//  This is a dummy effect so that an icon shows up in the UI.
	PersistentEffect = new class'X2Effect_Persistent';
	PersistentEffect.BuildPersistentEffect(1, true, false);
	PersistentEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.LocLongDescription, Template.IconImage, true,, Template.AbilitySourceName);
	Template.AddTargetEffect(PersistentEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	// Note: no visualization on purpose!

	Template.PrerequisiteAbilities.AddItem(default.TankLWProtectionProtocolAbilityName);

	Template.bCrossClassEligible = false;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWEverSafe-------------------------Colonel----------------------------------------------------
//---------------------------------------------------------------------------------------------------

	static function X2AbilityTemplate TankLWEverSafe()
{
	local X2AbilityTemplate								  Template;
	local X2AbilityCost_ActionPoints					  ActionPointCost;
	local X2Condition_UnitProperty						  TargetProperty;
	local X2Condition_UnitEffects						  EffectsCondition;
	local X2Condition_TankLWEverSafe					  TankLWEverSafeCondition;
	local X2Condition_AbilitySourceWeapon				  ProtectionProtocolCDRCondition, ProtectionProtocolMDRCondition, ProtectionProtocolBDRCondition;
	local X2Condition_UnitStatCheck						  ProtectionProtocolShieldedCondition;
	local X2Effect_TankClassLWProtectionProtocol		  ProtectionProtocolEffect;
	local X2Effect_TankClassLWProtectionProtocolCDR		  ProtectionProtocolCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeCDR  ProtectionProtocolMeleeCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMDR		  ProtectionProtocolMDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeMDR  ProtectionProtocolMeleeMDREffect;
	local X2Effect_TankClassLWProtectionProtocolBDR		  ProtectionProtocolBDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeBDR  ProtectionProtocolMeleeBDREffect;
	local X2Effect_PersistentStatChange					  ProtectionProtocolShieldedEffect;
	local X2AbilityTrigger_EventListener				  EventListener;
	local array<name>									  SkipExclusions;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWEverSafe');
	
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_EverSafe_TankLW";
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AdditionalAbilities.AddItem('TankLWEverSafePassiveInfo');

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 0;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);

	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);

	TargetProperty = new class'X2Condition_UnitProperty';
	TargetProperty.ExcludeDead = true;
	TargetProperty.ExcludeHostileToSource = true;
	TargetProperty.ExcludeFriendlyToSource = false;
	TargetProperty.RequireSquadmates = false;
	Template.AbilityTargetConditions.AddItem(TargetProperty);

	EffectsCondition = new class'X2Condition_UnitEffects';
	EffectsCondition.AddExcludeEffect(default.TankLWProtectionProtocolEffectName, 'AA_UnitIsImmune');
	EffectsCondition.AddExcludeEffect(class'X2AbilityTemplateManager'.default.PanickedName, 'AA_UnitIsImmune'); //Add this to prevent to be activated if unit has panic and do not moved the turn.
	Template.AbilityTargetConditions.AddItem(EffectsCondition);

	TankLWEverSafeCondition = new class'X2Condition_TankLWEverSafe';
	Template.AbilityTargetConditions.AddItem(TankLWEverSafeCondition);

	ProtectionProtocolEffect = new class'X2Effect_TankClassLWProtectionProtocol';
	ProtectionProtocolEffect.EffectName = default.TankLWProtectionProtocolEffectName;
	ProtectionProtocolEffect.PROTECTIONPROTOCOL_DODGE_BONUS_X2EFFECT = default.PROTECTIONPROTOCOL_DODGE_BONUS;
	ProtectionProtocolEffect.DuplicateResponse = eDupe_Ignore;            //  Gremlin effects should always be setup such that a target already under the effect is invalid.
	ProtectionProtocolEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolEffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolEffect.SetDisplayInfo(ePerkBuff_Bonus, default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	Template.AddTargetEffect(ProtectionProtocolEffect);

	ProtectionProtocolCDREffect = new class'X2Effect_TankClassLWProtectionProtocolCDR';
	ProtectionProtocolCDREffect.EffectName = default.TankLWProtectionProtocolCDREffectName;
	ProtectionProtocolCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION;
	ProtectionProtocolCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolCDREffect);

	ProtectionProtocolMeleeCDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeCDR';
	ProtectionProtocolMeleeCDREffect.EffectName = default.TankLWProtectionProtocolMeleeCDREffectName;
	ProtectionProtocolMeleeCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolMeleeCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeCDREffect);

	ProtectionProtocolMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMDR';
	ProtectionProtocolMDREffect.EffectName = default.TankLWProtectionProtocolMDREffectName;
	ProtectionProtocolMDREffect.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION;
	ProtectionProtocolMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMDREffect);

	ProtectionProtocolMeleeMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeMDR';
	ProtectionProtocolMeleeMDREffect.EffectName = default.TankLWProtectionProtocolMeleeMDREffectName;
	ProtectionProtocolMeleeMDREffect.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMeleeMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeMDREffect);

	ProtectionProtocolBDREffect = new class'X2Effect_TankClassLWProtectionProtocolBDR';
	ProtectionProtocolBDREffect.EffectName = default.TankLWProtectionProtocolBDREffectName;
	ProtectionProtocolBDREffect.PROTECTIONPROTOCOL_BEAM_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION;
	ProtectionProtocolBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDREffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolBDREffect);

	ProtectionProtocolMeleeBDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeBDR';
	ProtectionProtocolMeleeBDREffect.EffectName = default.TankLWProtectionProtocolMeleeBDREffectName;
	ProtectionProtocolMeleeBDREffect.PROTECTIONPROTOCOL_BEAM_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolMeleeBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeBDREffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_CV @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_CV, 'Gremlin_CV');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_MG @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_MG, 'Gremlin_MG');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_BM @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_BM, 'Gremlin_BM');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	// This ability triggers when the player ends his turn
	EventListener = new class'X2AbilityTrigger_EventListener';
	EventListener.ListenerData.Deferral = ELD_OnStateSubmitted;
	EventListener.ListenerData.EventID = 'PlayerTurnEnded';
	EventListener.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	EventListener.ListenerData.Filter = eFilter_Player;
	Template.AbilityTriggers.AddItem(EventListener);

	Template.bStationaryWeapon = true;
	Template.BuildNewGameStateFn = class 'X2Ability_SpecialistAbilitySet'.static.AttachGremlinToTarget_BuildGameState;
	Template.BuildVisualizationFn = class 'X2Ability_SpecialistAbilitySet'.static.GremlinSingleTarget_BuildVisualization;
	Template.bSkipPerkActivationActions = true;
	Template.bShowActivation = true;
	Template.ActivationSpeech = 'NullShield';

	Template.CustomSelfFireAnim = 'NO_DefenseProtocolA';

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWSurvivalTraining-----------------Brigadier--------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWSurvivalTraining()
{
	local X2AbilityTemplate                  Template;
	local X2AbilityCharges					 Charges;
	local X2AbilityCost_Charges				 ChargeCost;
	local X2AbilityCost_ActionPoints         ActionPointCost;
	local X2Condition_UnitProperty           PropertyCondition;
	local X2Effect_RemoveEffectsByDamageType RemoveEffects;
	local X2Effect_Regeneration				 RegenerationEffect;
	local X2AbilityTrigger_PlayerInput       InputTrigger;
	local array<name>                        SkipExclusions;
	
	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWSurvivalTraining');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_SurvivalTraining_TankLW";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_COLONEL_PRIORITY;  //Brigadier?
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.Hostility = eHostility_Defensive;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	Charges = new class 'X2AbilityCharges';
	Charges.InitialCharges = default.SURVIVALTRAINING_CHARGES;
	Template.AbilityCharges = Charges;
	
	ChargeCost = new class'X2AbilityCost_Charges';
	ChargeCost.NumCharges = 1;
	Template.AbilityCosts.AddItem(ChargeCost);

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);
	
	PropertyCondition = new class'X2Condition_UnitProperty';	
	PropertyCondition.ExcludeDead = true;                           // Can't hunkerdown while dead
	PropertyCondition.ExcludeFriendlyToSource = false;              // Self targeted
	PropertyCondition.ExcludeNoCover = true;                        // Unit must be in cover.
	Template.AbilityShooterConditions.AddItem(PropertyCondition);

	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);
	
	Template.AbilityToHitCalc = default.DeadEye;
	
	Template.AbilityTargetStyle = default.SelfTarget;

	InputTrigger = new class'X2AbilityTrigger_PlayerInput';
	Template.AbilityTriggers.AddItem(InputTrigger);

	RemoveEffects = new class'X2Effect_RemoveEffectsByDamageType';
	RemoveEffects.DamageTypesToRemove.AddItem('Fire');
	RemoveEffects.DamageTypesToRemove.AddItem('Poison');
	RemoveEffects.DamageTypesToRemove.AddItem(class'X2Effect_ParthenogenicPoison'.default.ParthenogenicPoisonType);
	RemoveEffects.DamageTypesToRemove.AddItem('Acid');
	Template.AddTargetEffect(RemoveEffects);

	// Build the regeneration effect
	RegenerationEffect = new class'X2Effect_Regeneration';
	RegenerationEffect.BuildPersistentEffect(1, true, true, false, eGameRule_PlayerTurnBegin);
	RegenerationEffect.HealAmount = default.SURVIVALTRAINING_REGEN_AMOUNT;
	RegenerationEffect.MaxHealAmount = default.SURVIVALTRAINING_MAX_REGEN_AMOUNT;
	RegenerationEffect.HealthRegeneratedName = 'TankLWSurvivalTrainingHealthRegenerated';
	Template.AddTargetEffect(RegenerationEffect);

	Template.AdditionalAbilities.AddItem('TankLWSurvivalTrainingHunkerDown');
	Template.PostActivationEvents.AddItem('TankLWSurvivalTrainingHunkerDown');
	
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.ActivationSpeech = 'HealingAlly';
	Template.CustomFireAnim = 'HL_SignalPoint';
	Template.bShowActivation = true;

	Template.bCrossClassEligible = default.SURVIVALTRAINING_AWC;

	return Template;
}

static function X2AbilityTemplate TankLWSurvivalTrainingHunkerDown()
{
	local X2AbilityTemplate                  Template;
	local X2Condition_UnitProperty           PropertyCondition;
	local X2Effect_PersistentStatChange      PersistentStatChangeEffect;
	local X2AbilityTrigger_EventListener     Trigger;
	local array<name>                        SkipExclusions;
	
	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWSurvivalTrainingHunkerDown');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_SurvivalTraining_TankLW";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_COLONEL_PRIORITY;
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	
	PropertyCondition = new class'X2Condition_UnitProperty';	
	PropertyCondition.ExcludeDead = true;                           // Can't hunkerdown while dead
	PropertyCondition.ExcludeFriendlyToSource = false;              // Self targeted
	PropertyCondition.ExcludeNoCover = true;                        // Unit must be in cover.
	Template.AbilityShooterConditions.AddItem(PropertyCondition);

	SkipExclusions.AddItem(class'X2StatusEffects'.default.BurningName);
	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);
	
	Template.AbilityToHitCalc = default.DeadEye;
	
	Template.AbilityTargetStyle = default.SelfTarget;

	Trigger = new class'X2AbilityTrigger_EventListener';
	Trigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	Trigger.ListenerData.EventID = 'TankLWSurvivalTrainingHunkerDown';
	Trigger.ListenerData.Filter = eFilter_Unit;
	Trigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	Template.AbilityTriggers.AddItem(Trigger);

	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.EffectName = 'HunkerDown';
	PersistentStatChangeEffect.BuildPersistentEffect(1 /* Turns */,,,,eGameRule_PlayerTurnBegin);
	PersistentStatChangeEffect.SetDisplayInfo(ePerkBuff_Bonus, Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Dodge, default.SURVIVALTRAINING_DODGE);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_Defense, default.SURVIVALTRAINING_DEFENSE);
	PersistentStatChangeEffect.DuplicateResponse = eDupe_Refresh;
	Template.AddTargetEffect(PersistentStatChangeEffect);

	Template.ConcealmentRule = eConceal_Always;

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = HunkerDownAbility_BuildVisualization;

	return Template;
}

simulated function HunkerDownAbility_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory History;
	local XComGameStateContext_Ability  Context;
	local StateObjectReference          InteractingUnitRef;
	local X2AbilityTemplate             AbilityTemplate;
	local XComGameState_Unit            UnitState;

	local VisualizationTrack        EmptyTrack;
	local VisualizationTrack        BuildTrack;

	local X2Action_PlaySoundAndFlyOver SoundAndFlyOver;

	History = `XCOMHISTORY;

	Context = XComGameStateContext_Ability(VisualizeGameState.GetContext());
	InteractingUnitRef = Context.InputContext.SourceObject;

	//Configure the visualization track for the shooter
	//****************************************************************************************	
	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(InteractingUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(InteractingUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(InteractingUnitRef.ObjectID);

	UnitState = XComGameState_Unit(BuildTrack.StateObject_NewState);
	
	//Civilians on the neutral team are not allowed to have sound + flyover for hunker down
	if( UnitState.GetTeam() != eTeam_Neutral )
	{
		
		SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, Context));
		if (UnitState.HasSoldierAbility('SharpshooterAim'))
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate('SharpshooterAim');
		}
		else if (UnitState.HasSoldierAbility('DeepCover') && XComGameState_Unit(BuildTrack.StateObject_OldState).ActionPoints.Find(class'X2CharacterTemplateManager'.default.DeepCoverActionPoint) != INDEX_NONE)
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate('DeepCover');
		}
		else
		{
			AbilityTemplate = class'X2AbilityTemplateManager'.static.GetAbilityTemplateManager().FindAbilityTemplate(Context.InputContext.AbilityTemplateName);
		}
		SoundAndFlyOver.SetSoundAndFlyOverParameters(SoundCue'SoundUI.HunkerDownCue', AbilityTemplate.LocFlyOverText, 'TankLWSurvivalTrainingHunkerDown', eColor_Good, AbilityTemplate.IconImage);
		OutVisualizationTracks.AddItem(BuildTrack);
	}
	//****************************************************************************************
}

//---------------------------------------------------------------------------------------------------
//-------------------------------------MIDDLE--------------------------------------------------------
//---------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------
// TankLWBallisticVests--------------------Corporal--------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWBallisticVests()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_PersistentStatChange		    PersistentStatChangeEffect;
	local X2Condition_TankLWBallisticVests      BallisticVestsCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWBallisticVests');

	Template.AdditionalAbilities.AddItem('TankLWBallisticVestsPassiveInfo');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_BallisticVests_TankLW";

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	BallisticVestsCondition = new class'X2Condition_TankLWBallisticVests';
	BallisticVestsCondition.RelevantSlot = eInvSlot_Utility;
	BallisticVestsCondition.RequireItemCategory = 'defense';
	Template.AbilityShooterConditions.AddItem(BallisticVestsCondition);

	PersistentStatChangeEffect = new class'X2Effect_PersistentStatChange';
	PersistentStatChangeEffect.BuildPersistentEffect(1, true, false, false);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_ArmorChance, default.BALLISTICVESTS_ARMOR_CHANCE);
	PersistentStatChangeEffect.AddPersistentStatChange(eStat_ArmorMitigation, default.BALLISTICVESTS_ARMOR_MITIGATION);
	Template.AddTargetEffect(PersistentStatChangeEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	Template.bCrossClassEligible = default.BALLISTICVESTS_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWChallenge------------------Sergeant---------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWChallenge()
{
	local X2AbilityTemplate						    Template;
	local X2AbilityCost_ActionPoints				ActionPointCost;
	local X2AbilityCooldown							Cooldown;
	local X2Condition_UnitProperty                  UnitPropertyCondition;
	local X2Condition_Visibility                    TargetVisibilityCondition;
	local X2Condition_UnitEffects                   UnitEffectsCondition;
    local X2AbilityTarget_Single                    SingleTarget;
	local X2Effect_TankClassLWChallenged            ChallengeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWChallenge');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_SERGEANT_PRIORITY;       
	Template.Hostility = eHostility_Offensive;                                                    
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.DisplayTargetHitChance = false;
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";
	
	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = false;
	Template.AbilityCosts.AddItem(ActionPointCost);

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = default.CHALLENGE_COOLDOWN;
	Template.AbilityCooldown = Cooldown;

	UnitEffectsCondition = new class'X2Condition_UnitEffects';
	UnitEffectsCondition.AddExcludeEffect(class'X2Effect_MindControl'.default.EffectName, 'AA_UnitIsMindControlled');
	UnitEffectsCondition.AddExcludeEffect(class'X2AbilityTemplateManager'.default.BoundName, 'AA_UnitIsBound');
	UnitEffectsCondition.AddExcludeEffect(class'X2Ability_CarryUnit'.default.CarryUnitEffectName, 'AA_CarryingUnit');
	Template.AbilityShooterConditions.AddItem(UnitEffectsCondition);

	//Can't use while dead
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	
	// Target Conditions
	UnitPropertyCondition = new class'X2Condition_UnitProperty'; //exclude cosmetic units?
	UnitPropertyCondition.ExcludeDead = true;
	UnitPropertyCondition.ExcludeFriendlyToSource = true;
	UnitPropertyCondition.RequireWithinRange = false;                              
	Template.AbilityTargetConditions.AddItem(UnitPropertyCondition);

	// Target must be visible and may use squad sight
	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);

	// Target cannot already be challenged.
	UnitEffectsCondition = new class'X2Condition_UnitEffects';
	UnitEffectsCondition.AddExcludeEffect(default.TankLWChallengeEffectName, 'AA_UnitIsImmune');
	Template.AbilityTargetConditions.AddItem(UnitEffectsCondition);

	// Add dead eye to guarantee hit
	Template.AbilityToHitCalc = default.DeadEye;

	//Can target a single Target
	SingleTarget = new class'X2AbilityTarget_Single';
	Template.AbilityTargetStyle = SingleTarget;
	
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	//Create the TankChallenge effect
	ChallengeEffect = new class'X2Effect_TankClassLWChallenged';
	ChallengeEffect.EffectName = default.TankLWChallengeEffectName;
	ChallengeEffect.DuplicateResponse = eDupe_Refresh;
	ChallengeEffect.BuildPersistentEffect(default.CHALLENGE_DURATION, false, true,,eGameRule_PlayerTurnEnd);
	ChallengeEffect.SetDisplayInfo(ePerkBuff_Penalty, Template.LocFriendlyName, default.TankLWChallengeDescriptionName, Template.IconImage);
	ChallengeEffect.VisualizationFn = TankLWChallengeVisualization;
	ChallengeEffect.EffectTickedVisualizationFn = TankLWChallengeVisualizationTicked;
	ChallengeEffect.EffectRemovedVisualizationFn = TankLWChallengeVisualizationRemoved;
	ChallengeEffect.bRemoveWhenTargetDies = true;
	Template.AddTargetEffect(ChallengeEffect);

	Template.AdditionalAbilities.AddItem('TankLWChallengeAim');
	Template.AdditionalAbilities.AddItem('TankLWChallengePassive');
	Template.AdditionalAbilities.AddItem('BroadcastTankLWMotivation');

	//Cinematic stuff /make it live
	Template.CustomFireAnim = 'HL_SignalPoint';
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.BuildVisualizationFn = TargetGettingChallenged_BuildVisualization;
	Template.CinescriptCameraType = "Mark_Target";

	Template.bCrossClassEligible = default.CHALLENGE_AWC;

	return Template;
}

static function TankLWChallengeVisualization(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	if( EffectApplyResult != 'AA_Success' )
	{
		return;
	}
	if (XComGameState_Unit(BuildTrack.StateObject_NewState) == none)
		return;

	class'X2StatusEffects'.static.AddEffectSoundAndFlyOverToTrack(BuildTrack, VisualizeGameState.GetContext(), default.ChallengeFriendlyName, '', eColor_Bad, "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW");
	class'X2StatusEffects'.static.AddEffectMessageToTrack(BuildTrack, default.ChallengeEffectAcquiredString, VisualizeGameState.GetContext());
	class'X2StatusEffects'.static.UpdateUnitFlag(BuildTrack, VisualizeGameState.GetContext());
}

static function TankLWChallengeVisualizationTicked(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	local XComGameState_Unit UnitState;

	UnitState = XComGameState_Unit(BuildTrack.StateObject_NewState);
	if (UnitState == none)
		return;

	// dead units should not be reported
	if( !UnitState.IsAlive() )
	{
		return;
	}

	class'X2StatusEffects'.static.AddEffectSoundAndFlyOverToTrack(BuildTrack, VisualizeGameState.GetContext(), default.ChallengeFriendlyName, '', eColor_Bad, "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW");
	class'X2StatusEffects'.static.AddEffectMessageToTrack(BuildTrack, default.ChallengeEffectTickedString, VisualizeGameState.GetContext());
	class'X2StatusEffects'.static.UpdateUnitFlag(BuildTrack, VisualizeGameState.GetContext());
}

static function TankLWChallengeVisualizationRemoved(XComGameState VisualizeGameState, out VisualizationTrack BuildTrack, const name EffectApplyResult)
{
	local XComGameState_Unit UnitState;

	UnitState = XComGameState_Unit(BuildTrack.StateObject_NewState);
	if (UnitState == none)
		return;

	// dead units should not be reported
	if( !UnitState.IsAlive() )
	{
		return;
	}

	class'X2StatusEffects'.static.AddEffectMessageToTrack(BuildTrack, default.ChallengeEffectLostString, VisualizeGameState.GetContext());
	class'X2StatusEffects'.static.UpdateUnitFlag(BuildTrack, VisualizeGameState.GetContext());
}

simulated function TargetGettingChallenged_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory				History;
	local XComGameStateContext_Ability		Context;
	local StateObjectReference				ShooterUnitRef;
	local StateObjectReference				TargetUnitRef;
	local XComGameState_Ability				Ability;
	local X2AbilityTemplate					AbilityTemplate;
	local AbilityInputContext				AbilityContext;
	
	local VisualizationTrack				EmptyTrack;
	local VisualizationTrack				BuildTrack;

	local X2Action_PlaySoundAndFlyOver		SoundAndFlyOver;
	local X2Action_WaitForAbilityEffect		WaitForAbilityEffect;
	local X2Action_SendInterTrackMessage    SendMessageAction;
	local X2Action_PlayAnimation            PlayAnimation;

	local Actor								TargetVisualizer, ShooterVisualizer;
	local X2VisualizerInterface				TargetVisualizerInterface, ShooterVisualizerInterface;
	local int								EffectIndex;

	local name								ApplyResult;
	

	History = `XCOMHISTORY;
	Context = XComGameStateContext_Ability(VisualizeGameState.GetContext());

	AbilityContext = Context.InputContext;
	Ability = XComGameState_Ability(History.GetGameStateForObjectID(AbilityContext.AbilityRef.ObjectID));
	AbilityTemplate = class'XComGameState_Ability'.static.GetMyTemplateManager().FindAbilityTemplate(AbilityContext.AbilityTemplateName);
	
	//Configure the visualization track for the shooter
	//****************************************************************************************
	ShooterUnitRef = Context.InputContext.SourceObject;
	ShooterVisualizer = History.GetVisualizer(ShooterUnitRef.ObjectID);
	ShooterVisualizerInterface = X2VisualizerInterface(ShooterVisualizer);

	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(ShooterUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(ShooterUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(ShooterUnitRef.ObjectID);

	if (AbilityTemplate != None)
	{
		if (!AbilityTemplate.bSkipFireAction && !AbilityTemplate.bSkipExitCoverWhenFiring)
		{
			class'X2Action_ExitCover'.static.AddToVisualizationTrack(BuildTrack, Context);
		}
	}

	SoundAndFlyOver = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(BuildTrack, Context));
	SoundAndFlyOver.SetSoundAndFlyOverParameters(None, Ability.GetMyTemplate().LocFlyOverText, '', eColor_Good, Ability.GetMyTemplate().IconImage);

	// Send an intertrack message letting the target know it can now die
	SendMessageAction = X2Action_SendInterTrackMessage(class'X2Action_SendInterTrackMessage'.static.AddToVisualizationTrack(BuildTrack, Context));
	SendMessageAction.SendTrackMessageToRef = Context.InputContext.PrimaryTarget;

	PlayAnimation = X2Action_PlayAnimation(class'X2Action_PlayAnimation'.static.AddToVisualizationTrack(BuildTrack, Context));
	PlayAnimation.Params.AnimName = 'HL_SignalPoint';

	if (AbilityTemplate != None && AbilityTemplate.AbilityTargetEffects.Length > 0)			//There are effects to apply
	{
		//Add any X2Actions that are specific to this effect being applied. These actions would typically be instantaneous, showing UI world messages
		//playing any effect specific audio, starting effect specific effects, etc. However, they can also potentially perform animations on the 
		//track actor, so the design of effect actions must consider how they will look/play in sequence with other effects.
		for (EffectIndex = 0; EffectIndex < AbilityTemplate.AbilityTargetEffects.Length; ++EffectIndex)
		{
			ApplyResult = Context.FindTargetEffectApplyResult(AbilityTemplate.AbilityTargetEffects[EffectIndex]);

			// Source effect visualization
			AbilityTemplate.AbilityTargetEffects[EffectIndex].AddX2ActionsForVisualizationSource(VisualizeGameState, BuildTrack, ApplyResult);
		}
	}

	if (ShooterVisualizerInterface != none)
	{
		ShooterVisualizerInterface.BuildAbilityEffectsVisualization(VisualizeGameState, BuildTrack);
	}

	if (AbilityTemplate != None)
	{
		if (!AbilityTemplate.bSkipFireAction && !AbilityTemplate.bSkipExitCoverWhenFiring)
		{
			class'X2Action_EnterCover'.static.AddToVisualizationTrack(BuildTrack, Context);
		}
	}

	OutVisualizationTracks.AddItem(BuildTrack);
	//****************************************************************************************

	//Configure the visualization track for the target
	//****************************************************************************************
	TargetUnitRef = Context.InputContext.PrimaryTarget;
	TargetVisualizer = History.GetVisualizer(AbilityContext.PrimaryTarget.ObjectID);
	TargetVisualizerInterface = X2VisualizerInterface(TargetVisualizer);

	BuildTrack = EmptyTrack;
	BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(TargetUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
	BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(TargetUnitRef.ObjectID);
	BuildTrack.TrackActor = History.GetVisualizer(TargetUnitRef.ObjectID);
					
	Ability = XComGameState_Ability(History.GetGameStateForObjectID(Context.InputContext.AbilityRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1));

	WaitForAbilityEffect = X2Action_WaitForAbilityEffect(class'X2Action_WaitForAbilityEffect'.static.AddToVisualizationTrack(BuildTrack, Context));
	WaitForAbilityEffect.ChangeTimeoutLength(5.0f);

	if (AbilityTemplate != None && AbilityTemplate.AbilityTargetEffects.Length > 0)			//There are effects to apply
	{
		//Add any X2Actions that are specific to this effect being applied. These actions would typically be instantaneous, showing UI world messages
		//playing any effect specific audio, starting effect specific effects, etc. However, they can also potentially perform animations on the 
		//track actor, so the design of effect actions must consider how they will look/play in sequence with other effects.
		for (EffectIndex = 0; EffectIndex < AbilityTemplate.AbilityTargetEffects.Length; ++EffectIndex)
		{
			ApplyResult = Context.FindTargetEffectApplyResult(AbilityTemplate.AbilityTargetEffects[EffectIndex]);

			// Target effect visualization
			AbilityTemplate.AbilityTargetEffects[EffectIndex].AddX2ActionsForVisualization(VisualizeGameState, BuildTrack, ApplyResult);
		}

		if (TargetVisualizerInterface != none)
		{
			//Allow the visualizer to do any custom processing based on the new game state. For example, units will create a death action when they reach 0 HP.
			TargetVisualizerInterface.BuildAbilityEffectsVisualization(VisualizeGameState, BuildTrack);
		}
	}
	
	OutVisualizationTracks.AddItem(BuildTrack);
	//****************************************************************************************
}

static function X2AbilityTemplate TankLWChallengeAim()
{
	local X2AbilityTemplate						Template;
	local X2Effect_ToHitModifier                ChallengeAimEffect;
	local X2Condition_TankLWChallengeAim        ChallengeAimCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWChallengeAim');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW";

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	ChallengeAimEffect = new class'X2Effect_ToHitModifier';
	ChallengeAimEffect.EffectName = default.TankLWChallengeAimEffectName;
	ChallengeAimEffect.DuplicateResponse = eDupe_Ignore;
	ChallengeAimEffect.BuildPersistentEffect(1, true, false);
	ChallengeAimEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	ChallengeAimEffect.AddEffectHitModifier(eHit_Success, default.CHALLENGE_AIM_BONUS, Template.LocFriendlyName);
	ChallengeAimEffect.AddEffectHitModifier(eHit_Crit, default.CHALLENGE_CRIT_CHANCE_BONUS, Template.LocFriendlyName);
	ChallengeAimCondition = new class'X2Condition_TankLWChallengeAim';
	ChallengeAimEffect.ToHitConditions.AddItem(ChallengeAimCondition);
	Template.AddTargetEffect(ChallengeAimEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	return Template;
}

static function X2AbilityTemplate TankLWChallengePassive()
{
	local X2AbilityTemplate					        Template;
	local X2Effect_TankClassLWChallengeKilledEnemy	TankLWChallengeNewEffect;

	`CREATE_X2ABILITY_TEMPLATE (Template, 'TankLWChallengePassive');
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.Hostility = eHostility_Neutral;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.AbilityToHitCalc = default.DeadEye;
	Template.bDisplayInUITooltip = true;
	Template.bDisplayInUITacticalText = true;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);
	Template.bSkipFireAction = true;
	Template.bShowActivation = false;

	//Effect serves to fire a custom event and that's it
	TankLWChallengeNewEffect = new class'X2Effect_TankClassLWChallengeKilledEnemy';
	TankLWChallengeNewEffect.eventid = 'ChallengeKill';
	TankLWChallengeNewEffect.bShowActivation = false;
	TankLWChallengeNewEffect.BuildPersistentEffect(1,true,true);
	Template.AddTargetEffect(TankLWChallengeNewEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;		
	return Template;
}


static function X2AbilityTemplate BroadcastTankLWMotivation()
{
	local X2AbilityTemplate					Template;
	local X2AbilityMultiTarget_Radius		RadiusMultiTarget;
	local X2Condition_UnitProperty			AllyCondition;	
	local X2AbilityTrigger_EventListener	EventListener;
	local X2Effect_PersistentStatChange		TankLWMotivationBonuses;
	
	`CREATE_X2ABILITY_TEMPLATE (Template, 'BroadcastTankLWMotivation');
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Challenge_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.Hostility = eHostility_Neutral;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityToHitCalc = default.DeadEye;
	Template.bDisplayInUITooltip = true;
	Template.bDisplayInUITacticalText = true;
	Template.bShowActivation = false;
	Template.bSkipFireAction = true;

	RadiusMultiTarget = new class'X2AbilityMultiTarget_Radius';
	RadiusMultiTarget.NumTargetsRequired = 1; 
	RadiusMultiTarget.bIgnoreBlockingCover = true; 
	RadiusMultiTarget.bAllowDeadMultiTargetUnits = false; 
	RadiusMultiTarget.bExcludeSelfAsTargetIfWithinRadius = true;
	RadiusMultiTarget.bUseWeaponRadius = false; 
	RadiusMultiTarget.ftargetradius = default.CHALLENGE_MOTIVATION_RADIUS * 1.5; 
	Template.AbilityMultiTargetStyle = RadiusMultiTarget;
	
	AllyCondition = new class'X2Condition_UnitProperty';
	AllyCondition.RequireSquadmates = true;
	AllyCondition.ExcludeAlien = true;
	AllyCondition.ExcludeRobotic = true;
	AllyCondition.ExcludeHostileToSource = true;
	AllyCondition.ExcludeFriendlyToSource = false;
	Template.AbilityMultiTargetConditions.AddItem(AllyCondition);

	EventListener = new class'X2AbilityTrigger_EventListener';
	EventListener.ListenerData.EventID = 'ChallengeKill';
	EventListener.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self;
	EventListener.ListenerData.Deferral = ELD_OnStateSubmitted;
	EventListener.ListenerData.Filter = eFilter_Unit;
	Template.AbilityTriggers.AddItem(EventListener);

	TankLWMotivationBonuses = new class 'X2Effect_PersistentStatChange';
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_Offense, float(default.CHALLENGE_MOTIVATION_AIM_BONUS));
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_CritChance, float(default.CHALLENGE_MOTIVATION_CRIT_BONUS));
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_Mobility, float(default.CHALLENGE_MOTIVATION_MOBILITY_BONUS));
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_Defense, float(default.CHALLENGE_MOTIVATION_DEFENSE_BONUS));
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_Dodge, float(default.CHALLENGE_MOTIVATION_DODGE_BONUS));
	TankLWMotivationBonuses.AddPersistentStatChange (eStat_Will, float(default.CHALLENGE_MOTIVATION_WILL_BONUS));
	TankLWMotivationBonuses.BuildPersistentEffect(default.CHALLENGE_MOTIVATION_DURATION,false,true,false,eGameRule_PlayerTurnEnd);
	TankLWMotivationBonuses.SetDisplayInfo (ePerkBuff_Bonus,Template.LocFriendlyName, Template.GetMyHelpText(), Template.IconImage,,, Template.AbilitySourceName); 
	TankLWMotivationBonuses.DuplicateResponse = eDupe_Refresh;
	Template.AddMultiTargetEffect(TankLWMotivationBonuses);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TankLWChallengeMotivation_BuildVisualization;
	return Template;
}

function TankLWChallengeMotivation_BuildVisualization(XComGameState VisualizeGameState, out array<VisualizationTrack> OutVisualizationTracks)
{
	local XComGameStateHistory				History;
    local XComGameStateContext_Ability		context;
    local StateObjectReference				InteractingUnitRef;
    local VisualizationTrack				EmptyTrack, BuildTrack, TargetTrack;
    local X2Action_PlayAnimation			PlayAnimationAction;
	local X2Action_PlaySoundAndFlyOver		SoundAndFlyoverTarget;
	local XComGameState_Ability				Ability;
	local XComGameState_Effect				EffectState;
	local XComGameState_Unit				UnitState;

    History = `XCOMHISTORY;
    context = XComGameStateContext_Ability(VisualizeGameState.GetContext());
	Ability = XComGameState_Ability(History.GetGameStateForObjectID(context.InputContext.AbilityRef.ObjectID, 1, VisualizeGameState.HistoryIndex - 1));
    InteractingUnitRef = context.InputContext.SourceObject;
    BuildTrack = EmptyTrack;
    BuildTrack.StateObject_OldState = History.GetGameStateForObjectID(InteractingUnitRef.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
    BuildTrack.StateObject_NewState = VisualizeGameState.GetGameStateForObjectID(InteractingUnitRef.ObjectID);
    BuildTrack.TrackActor = History.GetVisualizer(InteractingUnitRef.ObjectID);
    	
	PlayAnimationAction = X2Action_PlayAnimation(class'X2Action_PlayAnimation'.static.AddToVisualizationTrack(BuildTrack, context));
    PlayAnimationAction.Params.AnimName = 'HL_SignalEncourageA';
	PlayAnimationAction.bFinishAnimationWait = true;

	OutVisualizationTracks.AddItem(BuildTrack);

	foreach VisualizeGameState.IterateByClassType(class'XComGameState_Effect', EffectState)
	{
		if (EffectState.ApplyEffectParameters.EffectRef.SourceTemplateName == 'BroadcastTankLWMotivation')
		{
			TargetTrack = EmptyTrack;
			UnitState = XComGameState_Unit(VisualizeGameState.GetGameStateForObjectID(EffectState.ApplyEffectParameters.TargetStateObjectRef.ObjectID));
			if (UnitState != none && EffectState.StatChanges.Length > 0 && InteractingUnitRef.ObjectID != UnitState.ObjectID)
			{
				TargetTrack.StateObject_NewState = UnitState;
				TargetTrack.StateObject_OldState = History.GetGameStateForObjectID(UnitState.ObjectID, eReturnType_Reference, VisualizeGameState.HistoryIndex - 1);
				TargetTrack.TrackActor = UnitState.GetVisualizer();
				SoundandFlyoverTarget = X2Action_PlaySoundAndFlyOver(class'X2Action_PlaySoundAndFlyOver'.static.AddToVisualizationTrack(TargetTrack, context));
				SoundandFlyoverTarget.SetSoundAndFlyOverParameters(none, Ability.GetMyTemplate().LocFlyOverText, 'None', eColor_Good, Ability.GetMyTemplate().IconImage);
				OutVisualizationTracks.AddItem(TargetTrack);
			}
		}
	}
}

//---------------------------------------------------------------------------------------------------
// TankLWDecoy----------------------------Lieutenant-------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWDecoy()
{
	local X2AbilityTemplate									Template;
	local X2AbilityTargetStyle								TargetStyle;
	local X2AbilityTrigger									Trigger;
	local X2Effect_PersistentStatChange						StatChangeEffect;
	local X2Effect_TankClassLWDecoy	                        TransientItemEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWDecoy');

	Template.AdditionalAbilities.AddItem('TankLWDecoyPassiveInfo');

	// Give the normal MimicBeacon ability so that it will always show up in tactical, even without the item equipped
	Template.AdditionalAbilities.AddItem('MimicBeaconThrow');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Decoy_TankLW";

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);
	
	// Expand the unit's utility items to allow the transient item. This goes before the transient item effect
	StatChangeEffect = new class'X2Effect_PersistentStatChange';
	StatChangeEffect.EffectName = default.TankLWDecoyUtilityEffectName;
	StatChangeEffect.BuildPersistentEffect(1, true, false);
	StatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	StatChangeEffect.DuplicateResponse = eDupe_Ignore;
	StatChangeEffect.AddPersistentStatChange(eStat_UtilityItems, 1); // Can't think of any clever way to make this value based on the item template, so I'll just hardcode the item size for now
	Template.AddTargetEffect(StatChangeEffect);
	
	TransientItemEffect = new class'X2Effect_TankClassLWDecoy';
	TransientItemEffect.EffectName = default.TankLWDecoyEffectName;
	TransientItemEffect.BuildPersistentEffect(1, true, false);
	TransientItemEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	TransientItemEffect.DuplicateResponse = eDupe_Ignore;
	TransientItemEffect.AbilityTemplateName = 'MimicBeaconThrow';
	TransientItemEffect.ItemTemplateName = 'MimicBeacon';
	//TransientItemEffect.ClipSize = 2; //i think this works only for one equipped (armory) beacon in the inventary not for two or no equippment.
	//TransientItemEffect.UseItemAsAmmo = true; // only if at least one beacon is equipped in the armory you gain the free charge. the icon have to be removed in this case.
	Template.AddTargetEffect(TransientItemEffect);
	
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!
	
	Template.bCrossClassEligible = default.DECOY_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWShockAbsorbantArmor------------------Captain------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWShockAbsorbantArmor()
{
	local X2AbilityTemplate						    Template;
	local X2AbilityTargetStyle                      TargetStyle;
	local X2AbilityTrigger						    Trigger;
	local X2Effect_TankClassLWShockAbsorbantArmor	ShockAbsorbantArmorEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWShockAbsorbantArmor');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_ShockAbsorbantArmor_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AdditionalAbilities.AddItem('TankLWShockAbsorbantArmorPassiveInfo');

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	ShockAbsorbantArmorEffect = new class'X2Effect_TankClassLWShockAbsorbantArmor';
	ShockAbsorbantArmorEffect.SHOCKABSORBANTARMOR_DAMAGE_REDUCTION_X2EFFECT = default.SHOCKABSORBANTARMOR_DAMAGE_REDUCTION;
	ShockAbsorbantArmorEffect.SHOCKABSORBANTARMOR_TILES_X2EFFECT = default.SHOCKABSORBANTARMOR_TILES;
	ShockAbsorbantArmorEffect.BuildPersistentEffect(1, true, false, false);
	Template.AddTargetEffect(ShockAbsorbantArmorEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = default.SHOCKABSORBANTARMOR_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWLastChance------------------Brigadier-------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWLastChance()
{
	local X2AbilityTemplate             Template;
	local X2Effect_Sustain              SustainEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWLastChance');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_LastChance_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	SustainEffect = new class'X2Effect_Sustain';
	SustainEffect.BuildPersistentEffect(1, true, true);
	SustainEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, true,, Template.AbilitySourceName);
	Template.AddTargetEffect(SustainEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	// Note: no visualization on purpose!

	Template.PrerequisiteAbilities.AddItem(default.TankLWProtectionProtocolAbilityName);

	Template.AdditionalAbilities.AddItem('TankLWLastChanceTriggered');

	return Template;
}

static function X2DataTemplate TankLWLastChanceTriggered()
{
	local X2AbilityTemplate								  Template;
	local X2AbilityTrigger_EventListener				  EventTrigger;
	local X2Condition_AbilitySourceWeapon				  ProtectionProtocolCDRCondition, ProtectionProtocolMDRCondition, ProtectionProtocolBDRCondition;
	local X2Condition_UnitStatCheck						  ProtectionProtocolShieldedCondition;
	local X2Effect_TankClassLWProtectionProtocol		  ProtectionProtocolEffect;
	local X2Effect_TankClassLWProtectionProtocolCDR		  ProtectionProtocolCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeCDR  ProtectionProtocolMeleeCDREffect;
	local X2Effect_TankClassLWProtectionProtocolMDR		  ProtectionProtocolMDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeMDR  ProtectionProtocolMeleeMDREffect;
	local X2Effect_TankClassLWProtectionProtocolBDR		  ProtectionProtocolBDREffect;
	local X2Effect_TankClassLWProtectionProtocolMeleeBDR  ProtectionProtocolMeleeBDREffect;
	local X2Effect_PersistentStatChange					  ProtectionProtocolShieldedEffect;
	local X2Effect_ApplyMedikitHeal						  WHeal;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWLastChanceTriggered');

	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_LastChance_TankLW";
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.AbilitySourceName = 'eAbilitySource_Perk';

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;

	WHeal = new class'X2Effect_ApplyMedikitHeal';
	WHeal.PerUseHP = 4;
	Template.AddTargetEffect(Wheal);

	ProtectionProtocolEffect = new class'X2Effect_TankClassLWProtectionProtocol';
	ProtectionProtocolEffect.EffectName = default.TankLWProtectionProtocolEffectName;
	ProtectionProtocolEffect.PROTECTIONPROTOCOL_DODGE_BONUS_X2EFFECT = default.PROTECTIONPROTOCOL_DODGE_BONUS;
	ProtectionProtocolEffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolEffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolEffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolEffect.SetDisplayInfo(ePerkBuff_Bonus, default.TankLWLastChanceProtectionProtocolFriendlyName, default.TankLWProtectionProtocolDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	Template.AddTargetEffect(ProtectionProtocolEffect);

	ProtectionProtocolCDREffect = new class'X2Effect_TankClassLWProtectionProtocolCDR';
	ProtectionProtocolCDREffect.EffectName = default.TankLWProtectionProtocolCDREffectName;
	ProtectionProtocolCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION;
	ProtectionProtocolCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDREffect.SetDisplayInfo(ePerkBuff_Bonus, default.TankLWLastChanceProtectionProtocolSecondFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolCDREffect);

	ProtectionProtocolMeleeCDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeCDR';
	ProtectionProtocolMeleeCDREffect.EffectName = default.TankLWProtectionProtocolMeleeCDREffectName;
	ProtectionProtocolMeleeCDREffect.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeCDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeCDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeCDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolCDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolCDRCondition.MatchWeaponTemplate = 'Gremlin_CV';
	ProtectionProtocolMeleeCDREffect.TargetConditions.AddItem(ProtectionProtocolCDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeCDREffect);

	ProtectionProtocolMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMDR';
	ProtectionProtocolMDREffect.EffectName = default.TankLWProtectionProtocolMDREffectName;
	ProtectionProtocolMDREffect.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION;
	ProtectionProtocolMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDREffect.SetDisplayInfo(ePerkBuff_Bonus, default.TankLWLastChanceProtectionProtocolSecondFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMDREffect);

	ProtectionProtocolMeleeMDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeMDR';
	ProtectionProtocolMeleeMDREffect.EffectName = default.TankLWProtectionProtocolMeleeMDREffectName;
	ProtectionProtocolMeleeMDREffect.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_MAGNETIC_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeMDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeMDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeMDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolMDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolMDRCondition.MatchWeaponTemplate = 'Gremlin_MG';
	ProtectionProtocolMeleeMDREffect.TargetConditions.AddItem(ProtectionProtocolMDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeMDREffect);

	ProtectionProtocolBDREffect = new class'X2Effect_TankClassLWProtectionProtocolBDR';
	ProtectionProtocolBDREffect.EffectName = default.TankLWProtectionProtocolBDREffectName;
	ProtectionProtocolBDREffect.PROTECTIONPROTOCOL_BEAM_EXPL_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION;
	ProtectionProtocolBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin);
	ProtectionProtocolBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDREffect.SetDisplayInfo(ePerkBuff_Bonus, default.TankLWLastChanceProtectionProtocolSecondFriendlyName, default.TankLWProtectionProtocolDamageReductionDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_EXPL_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionSecondDescriptionName @ int(default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION * 100) @ default.TankLWProtectionProtocolDamageReductionThirdDescriptionName, "img:///UILibrary_TankClassLW.UIPerk_ProtectionProtocol_TankLW", true);
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolBDREffect);

	ProtectionProtocolMeleeBDREffect = new class'X2Effect_TankClassLWProtectionProtocolMeleeBDR';
	ProtectionProtocolMeleeBDREffect.EffectName = default.TankLWProtectionProtocolMeleeBDREffectName;
	ProtectionProtocolMeleeBDREffect.PROTECTIONPROTOCOL_BEAM_MELEE_DAMAGE_REDUCTION_X2EFFECT = default.PROTECTIONPROTOCOL_BEAM_MELEE_DMG_REDUCTION;
	ProtectionProtocolMeleeBDREffect.DuplicateResponse = eDupe_Ignore;
	ProtectionProtocolMeleeBDREffect.BuildPersistentEffect(1, false, true, false, eGameRule_PlayerTurnBegin); //displayinfo is set above
	ProtectionProtocolMeleeBDREffect.bRemoveWhenTargetDies = true;
	ProtectionProtocolBDRCondition = new class'X2Condition_AbilitySourceWeapon';
	ProtectionProtocolBDRCondition.MatchWeaponTemplate = 'Gremlin_BM';
	ProtectionProtocolMeleeBDREffect.TargetConditions.AddItem(ProtectionProtocolBDRCondition);
	Template.AddTargetEffect(ProtectionProtocolMeleeBDREffect);

    ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_CV @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_CV, 'Gremlin_CV');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_MG @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_MG, 'Gremlin_MG');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	ProtectionProtocolShieldedEffect = CreateShieldedEffect(default.TankLWEverSafeShieldedFriendlyName, default.TankLWProtectionProtocolShieldedDescriptionName @ default.PROTECTIONPROTOCOL_SHIELDHP_BM @ default.TankLWProtectionProtocolShieldedSecondDescriptionName, default.PROTECTIONPROTOCOL_SHIELDHP_BM, 'Gremlin_BM');
	ProtectionProtocolShieldedCondition = new class'X2Condition_UnitStatCheck';
	ProtectionProtocolShieldedCondition.AddCheckStat(eStat_ShieldHP, 0, eCheck_Exact);
	ProtectionProtocolShieldedEffect.TargetConditions.AddItem(ProtectionProtocolShieldedCondition);
	Template.AddTargetEffect(ProtectionProtocolShieldedEffect);

	EventTrigger = new class'X2AbilityTrigger_EventListener';
	EventTrigger.ListenerData.Deferral = ELD_OnStateSubmitted;
	EventTrigger.ListenerData.EventID = class'X2Effect_Sustain'.default.SustainEvent;
	EventTrigger.ListenerData.Filter = eFilter_Unit;
	EventTrigger.ListenerData.EventFn = class'XComGameState_Ability'.static.AbilityTriggerEventListener_Self_VisualizeInGameState;
	Template.AbilityTriggers.AddItem(EventTrigger);

	Template.PostActivationEvents.AddItem(class'X2Effect_Sustain'.default.SustainTriggeredEvent);
		
	Template.bSkipFireAction = true;
	Template.FrameAbilityCameraType = eCameraFraming_Never;
	Template.bStationaryWeapon = true;
	Template.BuildNewGameStateFn = class 'X2Ability_SpecialistAbilitySet'.static.AttachGremlinToTarget_BuildGameState;
	Template.BuildVisualizationFn = class 'X2Ability_SpecialistAbilitySet'.static.GremlinSingleTarget_BuildVisualization;
	Template.bSkipPerkActivationActions = true;
	Template.bShowActivation = true;

	Template.CustomSelfFireAnim = 'NO_DefenseProtocolA';

	return Template;
}

//---------------------------------------------------------------------------------------------------
// ------------------------------------BATTLE TANK---------------------------------------------------
//---------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------
// TankLWShieldHit-----------------------------Sergeant----------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWShieldHit()
{
	local X2AbilityTemplate                 Template;

	Template = PurePassive('TankLWShieldHit', "img:///UILibrary_TankClassLW.UIPerk_ShieldHit_TankLW", false, 'eAbilitySource_Perk');
	Template.AdditionalAbilities.AddItem('TankLWShieldHitRangeAttack');

	return Template;
}

static function X2AbilityTemplate TankLWShieldHitRangeAttack()
{
	local X2AbilityTemplate                        Template;
	local X2AbilityToHitCalc_StandardMelee         ToHitCalc;
	local X2AbilityTrigger_Event	               Trigger;
	local X2Effect_ApplyWeaponDamage               WeaponDamageConventionalEffect, WeaponDamageMagneticEffect, WeaponDamageBeamEffect;			           
	local X2Effect_Persistent                      TankLWShieldHitTargetEffect, DisorientedEffect;
	local X2Condition_UnitEffectsWithAbilitySource TankLWShieldHitTargetCondition;
	local X2AbilityTrigger_EventListener           EventListener;
	local X2Condition_UnitProperty                 SourceNotConcealedCondition;
	local X2Condition_Visibility			       TargetVisibilityCondition;
	local X2Condition_TankLWShieldHitRange         TankLWShieldHitRangeCondition;
	local X2Condition_TankLWShieldHitWeapon        TankLWShieldHitWeaponCondition;
	//local X2Condition_UnitEffects                  UnitEffectsCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWShieldHitRangeAttack');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_ShieldHit_TankLW";
	Template.Hostility = eHostility_Defensive;

	ToHitCalc = new class'X2AbilityToHitCalc_StandardMelee';
	ToHitCalc.bReactionFire = true;
	ToHitCalc.BuiltInHitMod = default.SHIELDHIT_MELEE_HITMOD;
	ToHitCalc.BuiltInCritMod = default.SHIELDHIT_MELEE_CRITMOD;
	Template.AbilityToHitCalc = ToHitCalc;

	Template.AbilityTargetStyle = default.SimpleSingleMeleeTarget;

	//  trigger on movement
	Trigger = new class'X2AbilityTrigger_Event';
	Trigger.EventObserverClass = class'X2TacticalGameRuleset_MovementObserver';
	Trigger.MethodName = 'InterruptGameState';
	Template.AbilityTriggers.AddItem(Trigger);
	Trigger = new class'X2AbilityTrigger_Event';
	Trigger.EventObserverClass = class'X2TacticalGameRuleset_MovementObserver';
	Trigger.MethodName = 'PostBuildGameState';
	Template.AbilityTriggers.AddItem(Trigger);
	//  trigger on an attack
	Trigger = new class'X2AbilityTrigger_Event';
	Trigger.EventObserverClass = class'X2TacticalGameRuleset_AttackObserver';
	Trigger.MethodName = 'InterruptGameState';
	Template.AbilityTriggers.AddItem(Trigger);

	//  it may be the case that enemy movement caused a concealment break, which made TankLWShieldHit applicable - attempt to trigger afterwards
	EventListener = new class'X2AbilityTrigger_EventListener';
	EventListener.ListenerData.Deferral = ELD_OnStateSubmitted;
	EventListener.ListenerData.EventID = 'UnitConcealmentBroken';
	EventListener.ListenerData.Filter = eFilter_Unit;
	EventListener.ListenerData.EventFn = BladestormConcealmentListener;
	EventListener.ListenerData.Priority = 55;
	Template.AbilityTriggers.AddItem(EventListener);
	
	Template.AbilityTargetConditions.AddItem(default.LivingHostileUnitDisallowMindControlProperty);
	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bRequireBasicVisibility = true;
	TargetVisibilityCondition.bDisablePeeksOnMovement = true; //Don't use peek tiles for over watch shots	
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);
	Template.AbilityTargetConditions.AddItem(class'X2Ability_DefaultAbilitySet'.static.OverwatchTargetEffectsCondition());

	TankLWShieldHitRangeCondition = new class'X2Condition_TankLWShieldHitRange';
	Template.AbilityTargetConditions.AddItem(TankLWShieldHitRangeCondition);

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);	
	Template.AddShooterEffectExclusions();

	//Don't trigger when the source is bound or carrying a unit // i think that is unnessecary
	//UnitEffectsCondition = new class'X2Condition_UnitEffects';
	//UnitEffectsCondition.AddExcludeEffect(class'X2AbilityTemplateManager'.default.BoundName, 'AA_UnitIsBound');
	//UnitEffectsCondition.AddExcludeEffect(class'X2Ability_CarryUnit'.default.CarryUnitEffectName, 'AA_CarryingUnit');
	//Template.AbilityShooterConditions.AddItem(UnitEffectsCondition);

	//Don't trigger when the source is concealed
	SourceNotConcealedCondition = new class'X2Condition_UnitProperty';
	SourceNotConcealedCondition.ExcludeConcealed = true;
	Template.AbilityShooterConditions.AddItem(SourceNotConcealedCondition);

	WeaponDamageConventionalEffect = new class'X2Effect_ApplyWeaponDamage';
	WeaponDamageConventionalEffect.EffectDamageValue.Damage = default.SHIELDHIT_MELEE_CONVENTIONAL_DAMAGE;
	WeaponDamageConventionalEffect.EffectDamageValue.Spread = default.SHIELDHIT_MELEE_CONVENTIONAL_SPREAD;
	WeaponDamageConventionalEffect.EffectDamageValue.Crit = default.SHIELDHIT_MELEE_CONVENTIONAL_CRIT;
	WeaponDamageConventionalEffect.EffectDamageValue.DamageType = 'Melee';
	TankLWShieldHitWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWShieldHitWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWShieldHitWeaponCondition.RequireWeaponTech = 'conventional';
	WeaponDamageConventionalEffect.TargetConditions.AddItem(TankLWShieldHitWeaponCondition);
	Template.AddTargetEffect(WeaponDamageConventionalEffect);

	WeaponDamageMagneticEffect = new class'X2Effect_ApplyWeaponDamage';
	WeaponDamageMagneticEffect.EffectDamageValue.Damage = default.SHIELDHIT_MELEE_MAGNETIC_DAMAGE;
	WeaponDamageMagneticEffect.EffectDamageValue.Spread = default.SHIELDHIT_MELEE_MAGNETIC_SPREAD;
	WeaponDamageMagneticEffect.EffectDamageValue.Crit = default.SHIELDHIT_MELEE_MAGNETIC_CRIT;
	WeaponDamageMagneticEffect.EffectDamageValue.DamageType = 'Melee';
	TankLWShieldHitWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWShieldHitWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWShieldHitWeaponCondition.RequireWeaponTech = 'magnetic';
	WeaponDamageMagneticEffect.TargetConditions.AddItem(TankLWShieldHitWeaponCondition);
	Template.AddTargetEffect(WeaponDamageMagneticEffect);

	WeaponDamageBeamEffect = new class'X2Effect_ApplyWeaponDamage';
	WeaponDamageBeamEffect.EffectDamageValue.Damage = default.SHIELDHIT_MELEE_BEAM_DAMAGE;
	WeaponDamageBeamEffect.EffectDamageValue.Spread = default.SHIELDHIT_MELEE_BEAM_SPREAD;
	WeaponDamageBeamEffect.EffectDamageValue.Crit = default.SHIELDHIT_MELEE_BEAM_CRIT;
	WeaponDamageBeamEffect.EffectDamageValue.DamageType = 'Melee';
	TankLWShieldHitWeaponCondition = new class'X2Condition_TankLWShieldHitWeapon';
	TankLWShieldHitWeaponCondition.RelevantSlot = eInvSlot_PrimaryWeapon;
	TankLWShieldHitWeaponCondition.RequireWeaponTech = 'beam';
	WeaponDamageBeamEffect.TargetConditions.AddItem(TankLWShieldHitWeaponCondition);
	Template.AddTargetEffect(WeaponDamageBeamEffect);

	DisorientedEffect = class'X2StatusEffects'.static.CreateDisorientedStatusEffect();
	DisorientedEffect.bRemoveWhenSourceDies = false;
	Template.AddTargetEffect(DisorientedEffect);

	//Prevent repeatedly hammering on a unit with TankLWShieldHit triggers.
	//(This effect does nothing, but enables many-to-many marking of which TankLWShieldHit attacks have already occurred each turn.)
	TankLWShieldHitTargetEffect = new class'X2Effect_Persistent';
	TankLWShieldHitTargetEffect.BuildPersistentEffect(1, false, true, true, eGameRule_PlayerTurnEnd);
	TankLWShieldHitTargetEffect.EffectName = 'TankLWShieldHitTarget';
	TankLWShieldHitTargetEffect.bApplyOnMiss = true; //Only one chance, even if you miss (prevents crazy flailing counter-attack chains with a Muton, for example)
	Template.AddTargetEffect(TankLWShieldHitTargetEffect);
	
	TankLWShieldHitTargetCondition = new class'X2Condition_UnitEffectsWithAbilitySource';
	TankLWShieldHitTargetCondition.AddExcludeEffect('TankLWShieldHitTarget', 'AA_DuplicateEffectIgnored');
	Template.AbilityTargetConditions.AddItem(TankLWShieldHitTargetCondition);

	Template.SourceMissSpeech = 'SwordMiss';

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.bShowActivation = true;
	Template.CustomFireAnim = 'FF_Melee';

	return Template;
}

//Must be static, because it will be called with a different object (an XComGameState_Ability)
//Used to trigger TankShieldHit when the source's concealment is broken by a unit in melee range (the regular movement triggers get called too soon)
static function EventListenerReturn BladestormConcealmentListener(Object EventData, Object EventSource, XComGameState GameState, Name EventID)
{
	local XComGameStateContext_Ability AbilityContext;
	local XComGameState_Unit ConcealmentBrokenUnit;
	local StateObjectReference BladestormRef;
	local XComGameState_Ability BladestormState;
	local XComGameStateHistory History;

	History = `XCOMHISTORY;

	ConcealmentBrokenUnit = XComGameState_Unit(EventSource);	
	if (ConcealmentBrokenUnit == None)
		return ELR_NoInterrupt;

	//Do not trigger if the Shieldhit Tank himself moved to cause the concealment break - only when an enemy moved and caused it.
	AbilityContext = XComGameStateContext_Ability(GameState.GetContext().GetFirstStateInEventChain().GetContext());
	if (AbilityContext != None && AbilityContext.InputContext.SourceObject != ConcealmentBrokenUnit.ConcealmentBrokenByUnitRef)
		return ELR_NoInterrupt;

	BladestormRef = ConcealmentBrokenUnit.FindAbility('TankLWShieldHitRangeAttack');
	if (BladestormRef.ObjectID == 0)
		return ELR_NoInterrupt;

	BladestormState = XComGameState_Ability(History.GetGameStateForObjectID(BladestormRef.ObjectID));
	if (BladestormState == None)
		return ELR_NoInterrupt;
	
	BladestormState.AbilityTriggerAgainstSingleTarget(ConcealmentBrokenUnit.ConcealmentBrokenByUnitRef, false);
	return ELR_NoInterrupt;
}

//---------------------------------------------------------------------------------------------------
// TankLWCombatDrugs---------------Lieutenant--------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWCombatDrugs()
{
	local X2AbilityTemplate									Template;
	local X2AbilityTargetStyle								TargetStyle;
	local X2AbilityTrigger									Trigger;
	local X2Effect_PersistentStatChange						StatChangeEffect;
	local X2Effect_TankClassLWCombatDrugs	                TransientItemEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWCombatDrugs');

	Template.AdditionalAbilities.AddItem('TankLWCombatDrugsPassiveInfo');

	// Give the normal TankLW Overdrive Serum ability so that it will always show up in tactical, even without the item equipped
	Template.AdditionalAbilities.AddItem('TankLWCombatStims');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_CombatDrugs_TankLW";

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	// Expand the unit's utility items to allow the transient item. This goes before the transient item effect
	StatChangeEffect = new class'X2Effect_PersistentStatChange';
	StatChangeEffect.EffectName = default.TankLWCombatDrugsUtilityEffectName;
	StatChangeEffect.BuildPersistentEffect(1, true, false);
	StatChangeEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	StatChangeEffect.DuplicateResponse = eDupe_Ignore;
	StatChangeEffect.AddPersistentStatChange(eStat_UtilityItems, 1); // Can't think of any clever way to make this value based on the item template, so I'll just hardcode the item size for now
	Template.AddTargetEffect(StatChangeEffect);
	
	TransientItemEffect = new class'X2Effect_TankClassLWCombatDrugs';
	TransientItemEffect.EffectName = default.TankLWCombatDrugsEffectName;
	TransientItemEffect.BuildPersistentEffect(1, true, false);
	TransientItemEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage, false,,Template.AbilitySourceName);
	TransientItemEffect.DuplicateResponse = eDupe_Ignore;
	TransientItemEffect.AbilityTemplateName = 'TankLWCombatStims';
	TransientItemEffect.ItemTemplateName = 'TankLWItemCombatStims';
	Template.AddTargetEffect(TransientItemEffect);
	
	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!
	
	Template.bCrossClassEligible = default.COMBATDRUGS_AWC;

	return Template;
}

static function X2AbilityTemplate TankLWCombatStims()  //We need to create our own combat stims.
{
	local X2AbilityTemplate             Template;
	local X2AbilityCost_Ammo            AmmoCost;
	local X2Effect_CombatStims          StimEffect;
	local X2Effect_PersistentStatChange StatEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWCombatStims');

	Template.AbilityCosts.AddItem(default.FreeActionCost);

	AmmoCost = new class'X2AbilityCost_Ammo';
	AmmoCost.iAmmo = 1;
	Template.AbilityCosts.AddItem(AmmoCost);

	Template.bUseAmmoAsChargesForHUD = true;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	Template.Hostility = eHostility_Defensive;
	Template.AbilitySourceName = 'eAbilitySource_Item';
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_combatstims";
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.COMBAT_STIMS_PRIORITY;
	Template.ActivationSpeech = 'CombatStim';
	Template.bShowActivation = true;
	Template.CustomSelfFireAnim = 'FF_FireMedkitSelf';

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;

	StimEffect = new class'X2Effect_CombatStims';
	StimEffect.BuildPersistentEffect((class'X2Ability_ItemGrantedAbilitySet'.default.COMBAT_STIM_DURATION), false, true, false, eGameRule_PlayerTurnEnd);
	StimEffect.SetDisplayInfo(ePerkBuff_Bonus, (class'X2Ability_ItemGrantedAbilitySet'.default.CombatStimBonusName), (class'X2Ability_ItemGrantedAbilitySet'.default.CombatStimBonusDesc), Template.IconImage);
	Template.AddTargetEffect(StimEffect);

	StatEffect = new class'X2Effect_PersistentStatChange';
	StatEffect.EffectName = 'StimStats'; //maybe change the effectname???
	StatEffect.DuplicateResponse = eDupe_Refresh;
	StatEffect.BuildPersistentEffect((class'X2Ability_ItemGrantedAbilitySet'.default.COMBAT_STIM_DURATION), false, true, false, eGameRule_PlayerTurnEnd);
	StatEffect.SetDisplayInfo(ePerkBuff_Bonus, (class'X2Ability_ItemGrantedAbilitySet'.default.CombatStimBonusName), (class'X2Ability_ItemGrantedAbilitySet'.default.CombatStimBonusDesc), Template.IconImage, false);
	StatEffect.AddPersistentStatChange(eStat_Mobility, (class'X2Ability_ItemGrantedAbilitySet'.default.COMBAT_STIM_MOBILITY_MOD), MODOP_Multiplication);
	Template.AddTargetEffect(StatEffect);

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWWarningShot--------------------Captain------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWWarningShot()
{
	local X2AbilityTemplate					Template;
	local X2AbilityCost_ActionPoints		ActionPointCost;
	local X2AbilityCost_Ammo				AmmoCost;
	local X2AbilityToHitCalc_StandardAim    ToHitCalc;
	local X2AbilityCooldown                 Cooldown;
	local X2AbilityTarget_Single            SingleTarget;
	local X2Condition_Visibility            VisibilityCondition;
	local X2Condition_UnitEffects           EffectsCondition;
	local X2Effect_Panicked                 PanicEffect, PanicEffectOnHit;
	local X2Effect_Knockback                KnockbackEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWWarningShot');

	Template.AdditionalAbilities.AddItem('TankLWWarningShotGraze');

	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.CLASS_CAPTAIN_PRIORITY;
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.Hostility = eHostility_Offensive;
	Template.eAbilityIconBehaviorHUD = eAbilityIconBehavior_AlwaysShow;
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_WarningShot_TankLW";
	Template.AbilityConfirmSound = "TacticalUI_ActivateAbility";

	ActionPointCost = new class'X2AbilityCost_ActionPoints';
	ActionPointCost.iNumPoints = 1;
	ActionPointCost.bConsumeAllPoints = true;
	Template.AbilityCosts.AddItem(ActionPointCost);

	AmmoCost = new class'X2AbilityCost_Ammo';
	AmmoCost.iAmmo = default.WARNING_SHOT_AMMO;
	Template.AbilityCosts.AddItem(AmmoCost);
	Template.bAllowAmmoEffects = true;
	Template.bAllowFreeFireWeaponUpgrade = true;
	Template.bAllowBonusWeaponEffects = false; //not sure what this does, maybe adding boni from perks like "lethal", or maybe it allows the holo and shredder to use without having the perk.
	Template.AddTargetEffect(default.WeaponUpgradeMissDamage);
	Template.AssociatedPassives.AddItem('HoloTargeting');
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	Cooldown = new class'X2AbilityCooldown';
	Cooldown.iNumTurns = default.WARNING_SHOT_COOLDOWN;
	Template.AbilityCooldown = Cooldown;

	ToHitCalc = new class'X2AbilityToHitCalc_StandardAim';
	ToHitCalc.bGuaranteedHit = false;
	ToHitCalc.bAllowCrit = false; //berprfen,kann auch kritisch treffen wird aber in Streifschaden umgewandelt.??
	Template.AbilityToHitCalc = ToHitCalc;
	Template.AbilityToHitOwnerOnMissCalc = ToHitCalc;
	
	SingleTarget = new class'X2AbilityTarget_Single';
	SingleTarget.OnlyIncludeTargetsInsideWeaponRange = true;
	Template.AbilityTargetStyle = SingleTarget;

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);
	Template.AddShooterEffectExclusions();

	Template.AbilityTargetConditions.AddItem(default.LivingHostileUnitOnlyProperty);
	//Template.AbilityTargetConditions.AddItem(default.LivingTargetUnitOnlyProperty); //Only for testing
	
	VisibilityCondition = new class'X2Condition_Visibility';
	VisibilityCondition.bRequireGameplayVisible = true;
	VisibilityCondition.bAllowSquadsight = true;
	Template.AbilityTargetConditions.AddItem(VisibilityCondition);

	EffectsCondition = new class'X2Condition_UnitEffects';
	EffectsCondition.AddExcludeEffect(class'X2AbilityTemplateManager'.default.PanickedName, 'AA_UnitIsImmune');
	Template.AbilityTargetConditions.AddItem(EffectsCondition);

	Template.AbilityTriggers.AddItem(default.PlayerInputTrigger);

	PanicEffect = class'X2StatusEffects'.static.CreatePanickedStatusEffect();
	PanicEffect.bApplyOnHit = false;
	PanicEffect.bApplyOnMiss = true;
	PanicEffect.ApplyChance = default.WARNING_SHOT_MISS_PANIC_CHANCE;
	PanicEffect.bRemoveWhenSourceDies = false;
	Template.AddTargetEffect(PanicEffect);

	PanicEffectOnHit = class'X2StatusEffects'.static.CreatePanickedStatusEffect();
	PanicEffectOnHit.bApplyOnHit = true;
	PanicEffectOnHit.bApplyOnMiss = false;
	PanicEffectOnHit.ApplyChance = default.WARNING_SHOT_HIT_PANIC_CHANCE;
	PanicEffectOnHit.bRemoveWhenSourceDies = false;
	Template.AddTargetEffect(PanicEffectOnHit);

	KnockbackEffect = new class'X2Effect_Knockback';
	KnockbackEffect.KnockbackDistance = 2;
	KnockbackEffect.bUseTargetLocation = true;
	Template.AddTargetEffect(KnockbackEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.BuildInterruptGameStateFn = TypicalAbility_BuildInterruptGameState;
	Template.TargetingMethod = class'X2TargetingMethod_OverTheShoulder';
	Template.bUsesFiringCamera = true;
	Template.CinescriptCameraType = "StandardGunFiring";
	Template.bShowActivation = true;

	Template.bCrossClassEligible = default.WARNING_SHOT_AWC;

	return Template;
}

static function X2AbilityTemplate TankLWWarningShotGraze()
{
	local X2AbilityTemplate						Template;
	local X2Effect_TankClassLWWarningShotGraze  GrazeEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWWarningShotGraze');

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AbilityToHitCalc = default.DeadEye;
	Template.AbilityTargetStyle = default.SelfTarget;
	Template.AbilityTriggers.AddItem(default.UnitPostBeginPlayTrigger);

	GrazeEffect = new class'X2Effect_TankClassLWWarningShotGraze';
	GrazeEffect.BuildPersistentEffect(1, true, true);
	Template.AddTargetEffect(GrazeEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWRevenge--------------------Major------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWRevenge()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_TankClassLWRevenge           FireEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWRevenge');

	Template.AdditionalAbilities.AddItem('TankLWRevengeShot');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_Revenge_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	FireEffect = new class'X2Effect_TankClassLWRevenge';
	FireEffect.BuildPersistentEffect(1, true, false, false, eGameRule_PlayerTurnBegin);
	FireEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(FireEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = default.REVENGE_AWC;

	return Template;
}

static function X2AbilityTemplate TankLWRevengeShot()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ReserveActionPoints ReserveActionPointCost;
	local X2AbilityToHitCalc_StandardAim    StandardAim;
	local X2Condition_UnitProperty          ShooterCondition;
	local X2AbilityTarget_Single            SingleTarget;
	local X2AbilityTrigger_Event	        Trigger;
	local X2Effect_Knockback				KnockbackEffect;
	local X2Condition_Visibility            TargetVisibilityCondition;
	local array<name>                       SkipExclusions;
	local X2Condition_TankLWRevenge         RevengeCondition;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWRevengeShot');
	
	Template.bDontDisplayInAbilitySummary = true;

	AmmoCost = new class'X2AbilityCost_Ammo';
	AmmoCost.iAmmo = 1;	
	Template.AbilityCosts.AddItem(AmmoCost);

	ReserveActionPointCost = new class'X2AbilityCost_ReserveActionPoints';
	ReserveActionPointCost.iNumPoints = 1;
	ReserveActionPointCost.AllowedTypes.AddItem(class'X2CharacterTemplateManager'.default.OverwatchReserveActionPoint);
	Template.AbilityCosts.AddItem(ReserveActionPointCost);
	
	StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	StandardAim.bReactionFire = true;
	Template.AbilityToHitCalc = StandardAim;
	Template.AbilityToHitOwnerOnMissCalc = StandardAim;

	Template.AbilityTargetConditions.AddItem(default.LivingHostileUnitDisallowMindControlProperty);

	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bRequireBasicVisibility = true;
	TargetVisibilityCondition.bDisablePeeksOnMovement = true;
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);

	Template.AbilityTargetConditions.AddItem(new class'X2Condition_EverVigilant');
	Template.AbilityTargetConditions.AddItem(class'X2Ability_DefaultAbilitySet'.static.OverwatchTargetEffectsCondition());

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);	
	ShooterCondition = new class'X2Condition_UnitProperty';
	ShooterCondition.ExcludeConcealed = true;
	Template.AbilityShooterConditions.AddItem(ShooterCondition);

	RevengeCondition = new class'X2Condition_TankLWRevenge';
	Template.AbilityShooterConditions.AddItem(RevengeCondition);

	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);
	
	SingleTarget = new class'X2AbilityTarget_Single';
	SingleTarget.OnlyIncludeTargetsInsideWeaponRange = true;
	Template.AbilityTargetStyle = SingleTarget;

	Trigger = new class'X2AbilityTrigger_Event';
	Trigger.EventObserverClass = class'X2TacticalGameRuleset_MovementObserver';
	Trigger.MethodName = 'InterruptGameState';
	Template.AbilityTriggers.AddItem(Trigger);
	
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_riflesupression";
	Template.Hostility = eHostility_Defensive;
	Template.bDisplayInUITooltip = false;
	Template.bDisplayInUITacticalText = false;
	Template.DisplayTargetHitChance = false;

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.bAllowFreeFireWeaponUpgrade = false;
	Template.bAllowAmmoEffects = true;
	Template.AssociatedPassives.AddItem('HoloTargeting');

	//  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	// Damage Effect

	Template.AddTargetEffect(default.WeaponUpgradeMissDamage);
	
	KnockbackEffect = new class'X2Effect_Knockback';
	KnockbackEffect.KnockbackDistance = 2;
	KnockbackEffect.bUseTargetLocation = true;
	Template.AddTargetEffect(KnockbackEffect);
	
	Template.bShowActivation = true;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWPreFire-----------------------------Colonel-------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWPreFire()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_TankClassLWPreFire           FireEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWPreFire');

	Template.AdditionalAbilities.AddItem('TankLWPreFireShot');

	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_PreFire_TankLW";
	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral; //eventuell ndern?

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	FireEffect = new class'X2Effect_TankClassLWPreFire';
	FireEffect.BuildPersistentEffect(1, true, false, false, eGameRule_PlayerTurnBegin);
	FireEffect.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(FireEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	//  NOTE: No visualization on purpose!

	Template.bCrossClassEligible = default.PREFIRE_AWC;

	return Template;
}

static function X2AbilityTemplate TankLWPreFireShot()
{
	local X2AbilityTemplate                 Template;
	local X2AbilityCost_Ammo                AmmoCost;
	local X2AbilityCost_ReserveActionPoints ReserveActionPointCost;
	local X2AbilityToHitCalc_StandardAim    StandardAim;
	local X2Condition_UnitProperty          ShooterCondition;
	local X2AbilityTarget_Single            SingleTarget;
	local X2AbilityTrigger_Event	        Trigger;
	local X2Effect_Knockback				KnockbackEffect;
	local X2Condition_Visibility            TargetVisibilityCondition;
	local array<name>                       SkipExclusions;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWPreFireShot');
	
	Template.bDontDisplayInAbilitySummary = true;

	AmmoCost = new class'X2AbilityCost_Ammo';
	AmmoCost.iAmmo = 1;	
	Template.AbilityCosts.AddItem(AmmoCost);

	ReserveActionPointCost = new class'X2AbilityCost_ReserveActionPoints';
	ReserveActionPointCost.iNumPoints = 1;
	ReserveActionPointCost.AllowedTypes.AddItem(class'X2CharacterTemplateManager'.default.OverwatchReserveActionPoint);
	Template.AbilityCosts.AddItem(ReserveActionPointCost);
	
	StandardAim = new class'X2AbilityToHitCalc_StandardAim';
	StandardAim.bReactionFire = true;
	Template.AbilityToHitCalc = StandardAim;
	Template.AbilityToHitOwnerOnMissCalc = StandardAim;

	Template.AbilityTargetConditions.AddItem(default.LivingHostileUnitDisallowMindControlProperty);

	TargetVisibilityCondition = new class'X2Condition_Visibility';
	TargetVisibilityCondition.bRequireGameplayVisible = true;
	TargetVisibilityCondition.bRequireBasicVisibility = true;
	TargetVisibilityCondition.bDisablePeeksOnMovement = true;
	Template.AbilityTargetConditions.AddItem(TargetVisibilityCondition);

	Template.AbilityTargetConditions.AddItem(new class'X2Condition_EverVigilant');
	Template.AbilityTargetConditions.AddItem(class'X2Ability_DefaultAbilitySet'.static.OverwatchTargetEffectsCondition());

	Template.AbilityShooterConditions.AddItem(default.LivingShooterProperty);	
	ShooterCondition = new class'X2Condition_UnitProperty';
	ShooterCondition.ExcludeConcealed = true;
	Template.AbilityShooterConditions.AddItem(ShooterCondition);

	SkipExclusions.AddItem(class'X2AbilityTemplateManager'.default.DisorientedName);
	Template.AddShooterEffectExclusions(SkipExclusions);
	
	SingleTarget = new class'X2AbilityTarget_Single';
	SingleTarget.OnlyIncludeTargetsInsideWeaponRange = true;
	Template.AbilityTargetStyle = SingleTarget;

	Trigger = new class'X2AbilityTrigger_Event';
	Trigger.EventObserverClass = class'X2TacticalGameRuleset_MovementObserver';
	Trigger.MethodName = 'InterruptGameState';
	Template.AbilityTriggers.AddItem(Trigger);
	
	Template.AbilitySourceName = 'eAbilitySource_Standard';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.IconImage = "img:///UILibrary_PerkIcons.UIPerk_xenobiology_overlays";
	Template.ShotHUDPriority = class'UIUtilities_Tactical'.const.OVERWATCH_PRIORITY;
	Template.Hostility = eHostility_Defensive; //eventuell entfernen?
	Template.bDisplayInUITooltip = false;
	Template.bDisplayInUITacticalText = false;
	Template.DisplayTargetHitChance = false;

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;
	Template.BuildVisualizationFn = TypicalAbility_BuildVisualization;
	Template.bAllowFreeFireWeaponUpgrade = false;
	Template.bAllowAmmoEffects = true;
	Template.AssociatedPassives.AddItem('HoloTargeting');

	//  Put holo target effect first because if the target dies from this shot, it will be too late to notify the effect.
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.HoloTargetEffect());
	Template.AddTargetEffect(class'X2Ability_GrenadierAbilitySet'.static.ShredderDamageEffect());

	// Damage Effect

	Template.AddTargetEffect(default.WeaponUpgradeMissDamage);
	
	KnockbackEffect = new class'X2Effect_Knockback';
	KnockbackEffect.KnockbackDistance = 2;
	KnockbackEffect.bUseTargetLocation = true;
	Template.AddTargetEffect(KnockbackEffect);
	
	Template.bShowActivation = true;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWStandBy-----------------------------Brigadier-----------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2AbilityTemplate TankLWStandBy()
{
	local X2AbilityTemplate						Template;
	local X2AbilityTargetStyle                  TargetStyle;
	local X2AbilityTrigger						Trigger;
	local X2Effect_ModifyReactionFire           ReactionFire;
	local X2Effect_TankClassLWStandBy			BonusDamageEffect;
	local X2Effect_TankClassLWStandByCrit		CritChanceEffect;

	`CREATE_X2ABILITY_TEMPLATE(Template, 'TankLWStandBy');
	Template.IconImage = "img:///UILibrary_TankClassLW.UIPerk_StandBy_TankLW";

	Template.AbilitySourceName = 'eAbilitySource_Perk';
	Template.eAbilityIconBehaviorHUD = EAbilityIconBehavior_NeverShow;
	Template.Hostility = eHostility_Neutral;
	Template.bIsPassive = true;

	Template.AbilityToHitCalc = default.DeadEye;

	TargetStyle = new class'X2AbilityTarget_Self';
	Template.AbilityTargetStyle = TargetStyle;

	Trigger = new class'X2AbilityTrigger_UnitPostBeginPlay';
	Template.AbilityTriggers.AddItem(Trigger);

	ReactionFire = new class'X2Effect_ModifyReactionFire';
	ReactionFire.bAllowCrit = true;
	ReactionFire.ReactionModifier = default.STANDBY_AIM_BONUS;
	ReactionFire.BuildPersistentEffect(1, true, true, true);
	ReactionFire.SetDisplayInfo(ePerkBuff_Passive, Template.LocFriendlyName, Template.GetMyLongDescription(), Template.IconImage,,,Template.AbilitySourceName);
	Template.AddTargetEffect(ReactionFire);

	BonusDamageEffect = new class'X2Effect_TankClassLWStandBy';
	BonusDamageEffect.STANDBY_BONUS_DAMAGE_X2EFFECT = default.STANDBY_BONUS_DAMAGE;
	BonusDamageEffect.BuildPersistentEffect(1, true, false, false);
	Template.AddTargetEffect(BonusDamageEffect);

	CritChanceEffect = new class 'X2Effect_TankClassLWStandByCrit';
	CritChanceEffect.STANDBY_BONUS_CRIT_CHANCE_X2EFFECT = default.STANDBY_BONUS_CRIT_CHANCE;
	CritChanceEffect.BuildPersistentEffect (1, true, true, true);
	Template.AddTargetEffect(CritChanceEffect);

	Template.BuildNewGameStateFn = TypicalAbility_BuildGameState;

	Template.bCrossClassEligible = default.STANDBY_AWC;

	return Template;
}

//---------------------------------------------------------------------------------------------------
// DefaultProperties
//---------------------------------------------------------------------------------------------------

DefaultProperties
{
	TankLWProtectionProtocolEffectName                         = "TankLWProtectionProtocolEffect";
	TankLWProtectionProtocolCDREffectName                      = "TankLWProtectionProtocolCDREffect";
	TankLWProtectionProtocolMeleeCDREffectName				   = "TankLWProtectionProtocolMeleeCDREffect";
	TankLWProtectionProtocolMDREffectName                      = "TankLWProtectionProtocolMDREffect";
	TankLWProtectionProtocolMeleeMDREffectName				   = "TankLWProtectionProtocolMeleeMDREffect";
	TankLWProtectionProtocolBDREffectName                      = "TankLWProtectionProtocolBDREffect";
	TankLWProtectionProtocolMeleeBDREffectName                 = "TankLWProtectionProtocolMeleeBDREffect";
	TankLWShieldedEffectName                                   = "TankLWShieldedEffect";
	TankLWTeamShieldedEffectName                               = "TankLWTeamShieldedEffect";
	TankLWDecoyUtilityEffectName                               = "TankLWDecoyUtilityEffect";
	TankLWDecoyEffectName                                      = "TankLWDecoyEffect";
	TankLWCombatDrugsUtilityEffectName                         = "TankLWCombatDrugsUtilityEffect";
	TankLWCombatDrugsEffectName                                = "TankLWCombatDrugsEffect";
	TankLWChallengeEffectName                                  = "TankLWChallengeEffect";
	TankLWChallengeAimEffectName                               = "TankLWChallengeAimEffect";
	TankLWMasochistEffectName                                  = "TankLWMasochistEffect";

	TankLWHereIAmAbilityName                                   = "TankLWHereIAm";
	TankLWProtectionProtocolAbilityName                        = "TankLWProtectionProtocol";
}

//---------------------------------------------------------------------------------------------------
// End
//---------------------------------------------------------------------------------------------------