class X2Condition_TankLWEverSafe extends X2Condition;

event name CallMeetsCondition(XComGameState_BaseObject kTarget)
{
	local XComGameState_Unit TargetUnit;
	local UnitValue NonMoveActionsThisTurn;
	local bool GotValue;

	TargetUnit = XComGameState_Unit(kTarget);
	if (TargetUnit == none)
		return 'AA_NotAUnit';

	if (!TargetUnit.GetMyTemplate().bCanBeRevived)
		return 'AA_UnitIsImmune';

	if (TargetUnit.IsDead())
		return 'AA_UnitIsDead';

	GotValue = TargetUnit.GetUnitValue('NonMoveActionsThisTurn', NonMoveActionsThisTurn);
	if (!GotValue || NonMoveActionsThisTurn.fValue == 0)
	{
		return 'AA_Success';
	}

	return 'AA_UnitIsNotImpaired';
}

event name CallMeetsConditionWithSource(XComGameState_BaseObject kTarget, XComGameState_BaseObject kSource)
{
	local XComGameState_Unit SourceUnit, TargetUnit;

	SourceUnit = XComGameState_Unit(kSource);
	TargetUnit = XComGameState_Unit(kTarget);

	if (SourceUnit == none || TargetUnit == none)
		return 'AA_NotAUnit';

	if (SourceUnit.ObjectID == TargetUnit.ObjectID)
		return 'AA_Success';

	return 'AA_UnitIsHostile';
}


		