class X2Effect_TankClassLWProtectionProtocolMeleeCDR extends X2Effect_Persistent;

var name MeleeDamageTypeName;

var float PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DAMAGE_REDUCTION_X2EFFECT;

function int GetDefendingDamageModifier(XComGameState_Effect EffectState, XComGameState_Unit Attacker, Damageable TargetDamageable, XComGameState_Ability AbilityState, const out EffectAppliedData AppliedData, const int CurrentDamage, X2Effect_ApplyWeaponDamage WeaponDamageEffect)
{
	local int DamageMod;
	local bool bIsMeleeDamage;
	local X2AbilityToHitCalc_StandardAim ToHitCalc;

	DamageMod = 0;
	if (EffectState.ApplyEffectParameters.EffectRef.SourceTemplateName == 'TankLWProtectionProtocol' || EffectState.ApplyEffectParameters.EffectRef.SourceTemplateName == 'TankLWEverSafe' || EffectState.ApplyEffectParameters.EffectRef.SourceTemplateName == 'TankLWLastChanceTriggered')
	{

		// The damage effect's DamageTypes must be empty or have melee in order to adjust the damage
		if (WeaponDamageEffect.EffectDamageValue.DamageType == MeleeDamageTypeName)
			bIsMeleeDamage = true;
		else if (WeaponDamageEffect.DamageTypes.Find(MeleeDamageTypeName) != INDEX_NONE)
			bIsMeleeDamage = true;
		else if ((WeaponDamageEffect.EffectDamageValue.DamageType == '') && (WeaponDamageEffect.DamageTypes.Length == 0))
			bIsMeleeDamage = true;
		else if ((Attacker.GetMyTemplate().CharacterGroupName == 'AdventStunLancer') && WeaponDamageEffect.DamageTypes.Find('Electrical') != INDEX_NONE)
			bIsMeleeDamage = true;

		if (bIsMeleeDamage)
		{
			ToHitCalc = X2AbilityToHitCalc_StandardAim(AbilityState.GetMyTemplate().AbilityToHitCalc);
			if (ToHitCalc != none && ToHitCalc.bMeleeAttack)
			{
				DamageMod = -int(float(CurrentDamage) * PROTECTIONPROTOCOL_CONVENTIONAL_MELEE_DAMAGE_REDUCTION_X2EFFECT);
			}
		}
	}
	
	return DamageMod;
}

defaultproperties
{
	MeleeDamageTypeName="melee"
}
