class X2StrategyElement_TankLWAcademyUnlocks extends X2StrategyElement config(TankClassLW);

//---------------------------------------------------------------------------------------------------
// ------------------------------------Variablen-----------------------------------------------------
//---------------------------------------------------------------------------------------------------

var config int RESILIENCE_UNLOCK_RANK;
var config int RESILIENCE_GTS_SUPPLY;

var config int HACKSEMINAR_UNLOCK_RANK;
var config int HACKSEMINAR_GTS_SUPPLY;
var config int HACKSEMINAR_GTS_INTEL;

//---------------------------------------------------------------------------------------------------
// ------------------------------------Templates-----------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;
		
	Templates.AddItem(TankLWResilienceUnlock());
	Templates.AddItem(TankLWHackSeminarUnlock());

	return Templates;
}

//---------------------------------------------------------------------------------------------------
// TankLWResilienceUnlock------------------GTS-------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2SoldierAbilityUnlockTemplate TankLWResilienceUnlock()
{
	local X2SoldierAbilityUnlockTemplate Template;
	local ArtifactCost Resources;

	`CREATE_X2TEMPLATE(class'X2SoldierAbilityUnlockTemplate', Template, 'TankLWResilienceUnlock');

	Template.AllowedClasses.AddItem('TankLW');
	Template.AbilityName = 'TankLWResilience';
	Template.strImage = "img:///UILibrary_TankClassLW.GTS.GTS_TankClassLW";
	
	// Requirements
	Template.Requirements.RequiredHighestSoldierRank = default.RESILIENCE_UNLOCK_RANK;
	Template.Requirements.RequiredSoldierClass = 'TankLW';
	Template.Requirements.RequiredSoldierRankClassCombo = true;
	Template.Requirements.bVisibleIfSoldierRankGatesNotMet = true;

	// Cost
	Resources.ItemTemplateName = 'Supplies';
	Resources.Quantity = default.RESILIENCE_GTS_SUPPLY;
	Template.Cost.ResourceCosts.AddItem(Resources);

	return Template;
}

//---------------------------------------------------------------------------------------------------
// TankLWHackSeminarUnlock------------------GTS------------------------------------------------------
//---------------------------------------------------------------------------------------------------

static function X2SoldierAbilityUnlockTemplate TankLWHackSeminarUnlock()
{
	local X2SoldierAbilityUnlockTemplate Template;
	local ArtifactCost Resources, SecondResources;

	`CREATE_X2TEMPLATE(class'X2SoldierAbilityUnlockTemplate', Template, 'TankLWHackSeminarUnlock');

	Template.AllowedClasses.AddItem('TankLW');
	Template.AbilityName = 'TankLWHackSeminar';
	Template.strImage = "img:///UILibrary_TankClassLW.GTS.GTS_TankClassLW_HackSeminar";
	
	// Requirements
	Template.Requirements.RequiredHighestSoldierRank = default.HACKSEMINAR_UNLOCK_RANK;
	Template.Requirements.RequiredSoldierClass = 'LW_Specialist';
	Template.Requirements.RequiredSoldierRankClassCombo = true; //not sure what this does
	Template.Requirements.bVisibleIfSoldierRankGatesNotMet = true;

	// Cost
	Resources.ItemTemplateName = 'Supplies';
	Resources.Quantity = default.HACKSEMINAR_GTS_SUPPLY;
	Template.Cost.ResourceCosts.AddItem(Resources);

	SecondResources.ItemTemplateName = 'Intel';
	SecondResources.Quantity = default.HACKSEMINAR_GTS_INTEL;
	Template.Cost.ResourceCosts.AddItem(SecondResources);

	return Template;
}
